PRINT N'Modificando [dbo].[GetAllegroSupervisor]...';


GO
ALTER PROCEDURE [dbo].[GetAllegroSupervisor]
(
	@IP				VARCHAR(50),
	@VCC			VARCHAR(50),
	@UserId			VARCHAR(50),
	@Type			BIT
)
AS
BEGIN
	-- ESTE SP RETORNA LA LISTA DE SUPERVISORES DE UN VCC DE TIPO ALLEGRO/OCC CON SUS WORKGROUPS DE AGENTES
	
	-- DECLARAMOS VARIABLES PARA ARMAR LA CONSULTA
	DECLARE @VCC_TYPE VARCHAR(25) = NULL
	DECLARE @SQL VARCHAR(MAX) = NULL
	DECLARE @TABLE_MMPRODAT VARCHAR(100) = NULL

	-- INDETIFICAMOS EL TIPO DE VCC
	SELECT @VCC_TYPE = V.[Type] 
		FROM [dbo].[VCC] V (NOLOCK) 
		WHERE V.[VCC] = @VCC

	-- EL TYPE 0 INDICA QUE LAS TABLAS SE ENCUENTRAN EN UN SERVIDOR EXTERNO
	IF @Type = 0
	BEGIN  
		SET @TABLE_MMPRODAT = '[' + @Ip + ']' + '.[MMProDat].[dbo].'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @TABLE_MMPRODAT = '[MMProDat].[dbo].'
	END
	
	--
	IF @VCC_TYPE = 'ALLEGRO'
	BEGIN
		-- ARMAMOS LA CONSULTA PRINCIPAL
		/*
		SET @SQL = '
			SELECT DISTINCT U.[VCC]					''vcc'',
							U.[Id]					''userId''
				FROM ' + @TABLE_MMPRODAT + '[SupervisorWorkgroup] SWG (NOLOCK)
				INNER JOIN ' + @TABLE_MMPRODAT + '[User] U (NOLOCK)
					ON U.[VCC] = SWG.[VCC]
						AND U.[Id] = SWG.[SupervisorId]
				WHERE SWG.[VCC] = ''' + @VCC + ''' '
		*/
		SET @SQL = '
			SELECT U.[VCC]					''vcc'',
					U.[Id]					''userId''
				FROM ' + @TABLE_MMPRODAT + '[User] U (NOLOCK)
				LEFT JOIN ' + @TABLE_MMPRODAT + '[SupervisorWorkgroup] SWG (NOLOCK)
					ON SWG.[VCC] = U.[VCC] 
						AND SWG.[SupervisorId] = U.[Id] 
				WHERE U.[VCC] = ''' + @VCC + ''' 
					AND U.[Id] = ''' + @UserId + '''
					AND U.[UserGroup] = ''supervisor'' '
	END
	ELSE IF @VCC_TYPE = 'OCC'
	BEGIN
		SET @SQL = '
			SELECT DISTINCT U.[VCC]					''vcc'',
							U.[Id]					''userId''
				FROM ' + @TABLE_MMPRODAT + '[User] U (NOLOCK) 
				INNER JOIN ' + @TABLE_MMPRODAT + '[GroupApplication] GA (NOLOCK)
					ON GA.[VCC] = U.[VCC]
						AND GA.[GroupId] = U.[UserGroup] 
				LEFT JOIN ' + @TABLE_MMPRODAT + '[UserCampaign] UC (NOLOCK) 
					ON UC.[VCC] = UC.[VCC]
						AND UC.[UserId] = U.[Id]
				LEFT JOIN ' + @TABLE_MMPRODAT + '[SupervisorWorkgroup] SW (NOLOCK)
					ON SW.[VCC] = U.[VCC]
						AND SW.[SupervisorId] = U.[Id]
						AND SW.[CampaignId] = UC.[CampaignId]
				WHERE GA.[VCC] = ''' + @VCC + '''
					AND GA.[ApplicationId] = ''supervisor''
					AND U.[Id] = ''' + @UserId + '''
				ORDER BY U.[Id] ASC, UC.[CampaignId] ASC 
		'
	END
	
	-- EJECUTAMOS LA CONSULTA
	EXEC(@SQL)
END
GO
PRINT N'Modificando [dbo].[GetAllegroSupervisors]...';


GO
ALTER PROCEDURE [dbo].[GetAllegroSupervisors]
(
	@IP				VARCHAR(50),
	@VCC			VARCHAR(50),
	@Type			BIT
)
AS
BEGIN
	-- ESTE SP RETORNA LA LISTA DE SUPERVISORES DE UN VCC DE TIPO ALLEGRO/OCC CON SUS WORKGROUPS DE AGENTES

	-- DECLARAMOS VARIABLES PARA ARMAR LA CONSULTA
	DECLARE @VCC_TYPE VARCHAR(25) = NULL
	DECLARE @SQL VARCHAR(MAX) = NULL
	DECLARE @TABLE_MMPRODAT VARCHAR(100) = NULL

	-- INDETIFICAMOS EL TIPO DE VCC
	SELECT @VCC_TYPE = V.[Type] 
		FROM [dbo].[VCC] V (NOLOCK) 
		WHERE V.[VCC] = @VCC

	-- EL TYPE 0 INDICA QUE LAS TABLAS SE ENCUENTRAN EN UN SERVIDOR EXTERNO
	IF @Type = 0
	BEGIN  
		SET @TABLE_MMPRODAT = '[' + @Ip + ']' + '.[MMProDat].[dbo].'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @TABLE_MMPRODAT = '[MMProDat].[dbo].'
	END
	
	--
	IF @VCC_TYPE = 'ALLEGRO'
	BEGIN
		-- ARMAMOS LA CONSULTA PRINCIPAL
		/*
		SET @SQL = '
			SELECT U.[VCC]					''vcc'',
					U.[Id]					''userId'',
					U.[Name]				''userName'',
					SWG.[CampaignId]		''campaignId'',
					SWG.[WorkgroupId]		''workGroupId''
				FROM ' + @TABLE_MMPRODAT + '[SupervisorWorkgroup] SWG (NOLOCK)
				INNER JOIN ' + @TABLE_MMPRODAT + '[User] U (NOLOCK)
					ON U.[VCC] = SWG.[VCC]
						AND U.[Id] = SWG.[SupervisorId]
				WHERE SWG.[VCC] = ''' + @VCC + ''' '
		*/
		SET @SQL = '
			SELECT U.[VCC]					''vcc'',
					U.[Id]					''userId'',
					U.[Name]				''userName'',
					SWG.[CampaignId]		''campaignId'',
					SWG.[WorkgroupId]		''workGroupId''
				FROM ' + @TABLE_MMPRODAT + '[User] U (NOLOCK)
				LEFT JOIN ' + @TABLE_MMPRODAT + '[SupervisorWorkgroup] SWG (NOLOCK)
					ON SWG.[VCC] = U.[VCC] 
						AND SWG.[SupervisorId] = U.[Id] 
				WHERE U.[VCC] = ''' + @VCC + ''' 
					AND U.[UserGroup] = ''supervisor'' '
	END
	ELSE IF @VCC_TYPE = 'OCC'
	BEGIN
		SET @SQL = '
			SELECT U.[VCC]					''vcc'',
					U.[Id]					''userId'',
					U.[Name]				''userName'',
					--U.[UserGroup],
					UC.[CampaignId]			''campaignId'',
					SW.[WorkgroupId]		''workGroupId''
				FROM ' + @TABLE_MMPRODAT + '[User] U (NOLOCK) 
				INNER JOIN ' + @TABLE_MMPRODAT + '[GroupApplication] GA (NOLOCK)
					ON GA.[VCC] = U.[VCC]
						AND GA.[GroupId] = U.[UserGroup] 
				LEFT JOIN ' + @TABLE_MMPRODAT + '[UserCampaign] UC (NOLOCK) 
					ON UC.[VCC] = UC.[VCC]
						AND UC.[UserId] = U.[Id]
				LEFT JOIN ' + @TABLE_MMPRODAT + '[SupervisorWorkgroup] SW (NOLOCK)
					ON SW.[VCC] = U.[VCC]
						AND SW.[SupervisorId] = U.[Id]
						AND SW.[CampaignId] = UC.[CampaignId]
				WHERE GA.[VCC] = ''' + @VCC + '''
					AND GA.[ApplicationId] = ''supervisor''
				ORDER BY U.[Id] ASC, UC.[CampaignId] ASC 
		'
	END
	
	-- EJECUTAMOS LA CONSULTA
	EXEC(@SQL)
END
GO
PRINT N'Modificando [dbo].[GetStudyResultSummary]...';


GO
ALTER PROCEDURE [dbo].[GetStudyResultSummary]
(
	@VCC					VARCHAR(50),
	@StudyId				VARCHAR(200),
	@NewStructure			VARCHAR(1)
)
AS
BEGIN
	SET NOCOUNT ON

	BEGIN
		SELECT
			B.[Name]						'processName',
			A.[Name]						'studyName',
			A.[Description]					'studyDescription',
			A.[TemplateId]					'templateId'
		FROM [dbo].[Study] A (NOLOCK)
		INNER JOIN Process B ON A.ProcessId = B.[Name]
		WHERE A.[VCC] = @VCC 
			AND A.[Name] = @StudyId
	END

	BEGIN
		SELECT
			[VCC]							'vcc',
			[StudyId]						'studyId',
			[TemplateId]					'templateId',
			[TemplateThemeId]				'templateThemeId',
			[ID]							'id',
			[Description]					'description',
			[Category1]						'category1',
			[Category2]						'category2',
			[Total]							'total',
			[Duration]						'duration',
			[Silence]						'silence',
			[Confidence]					'confidence',
			[CreatedDate]					'createdDate',
			[CreatedByUserId]				'createdByUserId',
			[LastModifiedDate]				'lastModifiedDate',
			[LastModifiedByUserId]			'lastModifiedByUserId'
		FROM [dbo].[StudyResultSummary] (NOLOCK)
		WHERE [VCC] = @VCC 
			AND [StudyId] = @StudyId
	END

	IF(@NewStructure IS NULL)
	BEGIN
		SELECT
			A.[TemplateThemeId]									'templateThemeId',
			A.[TemplateThemeItemId]								'templateThemeItemId',
			--ISNULL(D.[Query], A.[TemplateThemeItemId])			'query', -- Si es NULL se mostrara valor de TemplateThemeItem campo ID.
			ISNULL(ISNULL(D.[Query], E.[EntityName]),'')			'query', -- Si es NULL se mostrara valor de TemplateThemeItem campo ID.
			ISNULL(C.[Channel], AI.[Channel])					'interactionType',
			-- REPLACE(A.[TranscriptionId], '_0_1', '')			'transcriptionId',

			CASE WHEN C.[Channel] IS NOT NULL 
					AND C.[Channel] = 'CALL' 
				--THEN REPLACE(A.[TranscriptionId], '_0_1', '') 
				THEN A.[TranscriptionId]
				ELSE AI.[ID] END								'transcriptionId',

			C.[Section]											'section',
			C.[Part]											'part',
			AI.[Folder]											'folder',
			AI.[Campaign]										'campaign',
			--ISNULL(C.[Agent], '')								'agent'
			CASE WHEN C.[Channel] IS NOT NULL 
					AND C.[Channel] = 'CALL' 
				THEN ISNULL(C.[Agent], '') 
				ELSE ISNULL(AI.[FirstTakedAgent], '') END		'agent',
			CASE WHEN C.[Channel] IS NOT NULL 
					AND C.[Channel] = 'CALL' 
				THEN ISNULL(C.[IsTranscribed], '') 
				ELSE ISNULL(AI.[IsTranscribed], '') END			'isTranscribed',
			CASE WHEN C.[Channel] IS NOT NULL
					AND C.[Channel] = 'CALL' 
				THEN ISNULL(C.[IsCancel], '') 
				ELSE ISNULL(AI.[IsCancel], '') END				'isCancel'
		FROM 
			[dbo].[StudyResultSummaryDetail] A (NOLOCK)
			INNER JOIN [dbo].[Study] S (NOLOCK) 
				ON S.[VCC] = A.[VCC] 
					AND S.[Name] = A.[StudyId]
			INNER JOIN [dbo].[HistoricTemplateThemeItem] B (NOLOCK) 
				ON S.[TemplateId] = B.[TemplateId] 
					AND A.[TemplateThemeId] = B.[TemplateThemeId] 
					AND A.[TemplateThemeItemId] = B.[ID]
					AND B.[StudyId] = S.[Name]
			
			LEFT JOIN [dbo].[Audio] C (NOLOCK)  -- (!)SE CAMBIO EL INNER POR LEFT PARA CONSIDER LAS TRANSCRIPCIONES DE CANALES ASINCRINOS
				ON A.[VCC] = C.[VCC]
					AND A.[TranscriptionId] = CONCAT(C.[ID], '_', C.[Section], '_', C.[Part])
			LEFT JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
				ON S.[VCC] = PA.[VCC] 
					AND S.[ProcessId] = PA.[ProcessId] 
					AND A.[TranscriptionId] = CONCAT(PA.[AudioId], '_', PA.[Section], '_', PA.[Part])

			LEFT JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON A.[TranscriptionId] = CONCAT(AI.[Channel], '_', AI.[Campaign], '_', AI.[Folder], '_', REPLACE(AI.[ID], ':', '_'))
			LEFT JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
				ON PAI.[VCC] = S.[VCC]
					AND PAI.[ProcessId] = S.[ProcessId]
					AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = A.[TranscriptionId]

			LEFT JOIN [dbo].[GenericQuery] D (NOLOCK) 
				ON B.[VCC] = D.[VCC] 
					AND  B.[ID] = D.[Name] -- Se agrega LEFT JOIN para poder mostrar.

			LEFT JOIN [dbo].[TemplateThemeItemEntity] E 
				ON A.TemplateThemeId = E.TemplateThemeId
		WHERE
			B.[VCC] IN ('system', @VCC) AND
			A.[StudyId] = @StudyId
	END
	ELSE
	BEGIN
		-- ESTE BLOQUE NUNCA SE USA, EL UNICO LLAMADO DE LA FUNCION INSERTA DIRECTAMENTE NULL PARA LA VARIABLE @NewStructure
		SELECT
			A.[TemplateThemeId]									'templateThemeId',
			A.[TemplateThemeItemId]								'templateThemeItemId',
			D.[Query]											'query',
			ISNULL(C.[Channel], AI.[Channel])					'interactionType',
			CASE WHEN C.[Channel] IS NOT NULL 
					AND C.[Channel] = 'CALL' 
				THEN A.[TranscriptionId] 
				ELSE AI.[ID] END								'transcriptionId',
			C.[Section]											'section',
			C.[Part]											'part',
			AI.[Folder]											'folder',
			AI.[Campaign]										'campaign',
			--ISNULL(C.[Agent], '')								'agent',
			CASE WHEN C.[Channel] IS NOT NULL 
					AND C.[Channel] = 'CALL' 
				THEN ISNULL(C.[Agent], '') 
				ELSE ISNULL(AI.[FirstTakedAgent], '') END		'agent',
			CASE WHEN C.[Channel] IS NOT NULL 
					AND C.[Channel] = 'CALL' 
				THEN ISNULL(C.[IsTranscribed], '') 
				ELSE ISNULL(AI.[IsTranscribed], '') END			'isTranscribed',
			CASE WHEN C.[Channel] IS NOT NULL
					AND C.[Channel] = 'CALL' 
				THEN ISNULL(C.[IsCancel], '') 
				ELSE ISNULL(AI.[IsCancel], '') END				'isCancel'
			
		FROM 
			[dbo].[StudyResultSummaryDetail] A (NOLOCK)
			INNER JOIN [dbo].[Study] S (NOLOCK) 
				ON S.[VCC] = A.[VCC] 
					AND S.[Name] = A.[StudyId]
			INNER JOIN [dbo].[HistoricTemplateThemeItem] B (NOLOCK) 
				ON S.[TemplateId] = B.[TemplateId] 
					AND A.[TemplateThemeId] = B.[TemplateThemeId] 
					AND A.[TemplateThemeItemId] = B.[ID]
					AND B.[StudyId] = S.[Name]
			
			LEFT JOIN [dbo].[Audio] C (NOLOCK) 
				ON A.[VCC] = C.[VCC]
					AND A.[TranscriptionId] = CONCAT(C.[ID], '_', C.[Section], '_', C.[Part])
			INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
				ON S.[VCC] = PA.[VCC] 
					AND S.[ProcessId] = PA.[ProcessId] 
					AND A.[TranscriptionId] = CONCAT(PA.[AudioId], '_', PA.[Section], '_', PA.[Part])
			
			LEFT JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON A.[TranscriptionId] = CONCAT(AI.[Channel], '_', AI.[Campaign], '_', AI.[Folder], '_', REPLACE(AI.[ID], ':', '_'))
			LEFT JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
				ON PAI.[VCC] = S.[VCC]
					AND PAI.[ProcessId] = S.[ProcessId]
					AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = A.[TranscriptionId]

			INNER JOIN [dbo].[GenericQuery] D (NOLOCK) 
				ON B.[VCC] = D.[VCC] 
					AND  B.[ID] = D.[Name]
		WHERE
			B.[VCC] IN ('system', @VCC) AND
			A.[StudyId] = @StudyId
	END
	
	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetAllegroCampaignMembers]...';


GO
CREATE PROCEDURE [dbo].[GetAllegroCampaignMembers]
(
	@IP				VARCHAR(50),
	@VCC			VARCHAR(50),
	@Campaigns		VARCHAR(MAX),
	@Type			BIT
)
AS
BEGIN
	-- ESTE SP RETORNA LA LISTA DE SUPERVISORES DE UN VCC DE TIPO ALLEGRO/OCC CON SUS WORKGROUPS DE AGENTES
	
	-- DECLARAMOS VARIABLES PARA ARMAR LA CONSULTA
	DECLARE @SQL VARCHAR(MAX) = NULL
	DECLARE @TABLE_MMPRODAT VARCHAR(100) = NULL

	-- EL TYPE 0 INDICA QUE LAS TABLAS SE ENCUENTRAN EN UN SERVIDOR EXTERNO
	IF @Type = 0
	BEGIN  
		SET @TABLE_MMPRODAT = '[' + @Ip + ']' + '.[MMProDat].[dbo].'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @TABLE_MMPRODAT = '[MMProDat].[dbo].'
	END
	
	-- ARMAMOS LA CONSULTA PRINCIPAL
	/*
	SET @SQL = '
		SELECT DISTINCT UC.[VCC]					''vcc'',
						UC.[CampaignId]				''campaign'',
						UC.[Id]						''userId''
			FROM ' + @TABLE_MMPRODAT + '[UserCampaign] UC (NOLOCK)
			WHERE UC.[VCC] = ''' + @VCC + ''' 
				AND UC.[CampaigniD] IN (SELECT Value FROM [dbo].[split](''' + @Campaigns + ''','','')) '
	*/

	SELECT DISTINCT UC.[VCC]									'vcc',
					UC.[CampaignId]								'campaignId',
					UC.[UserId]									'userId',
					IIF(SWG.[SupervisorId] IS NOT NULL, 1, 0)	'isSupervisor',
					IIF(A.[UserId] IS NOT NULL, 1, 0)			'isAgent',
					SWG.[WorkgroupId]							'supervisorWorkgroup',
					A.[WorkgroupId]								'agentWorkgroup'
		FROM [MMProDat].[dbo].[UserCampaign] UC (NOLOCK)
		LEFT JOIN [MMProDat].[dbo].[Agent] A (NOLOCK)
			ON A.[VCC] = UC.[VCC]
				AND A.[UserId] = UC.[UserId]
		LEFT JOIN [MMProDat].[dbo].[SupervisorWorkgroup] SWG (NOLOCK)
			ON SWG.[VCC] = UC.[VCC]
				AND SWG.[CampaignId] = UC.[CampaignId]
				AND SWG.[SupervisorId] = UC.[UserId]
 		WHERE UC.[VCC] = @VCC 
			AND UC.[CampaignId] IN (SELECT Value FROM [dbo].[split](@Campaigns,','))

	-- EJECUTAMOS LA CONSULTA
	EXEC(@SQL)
END
GO
PRINT N'Actualización completada.';


GO
