
PRINT N'Altering Procedure [dbo].[GetSentimentAnalysisResult]...';

GO

ALTER PROCEDURE [dbo].[GetSentimentAnalysisResult] (
	@VCC varchar(50),
	@InteractionId varchar(250),
	@InteractionSection numeric(5,0),
	@InteractionPart numeric(5,0),
	@EndDate varchar(50)
   
	)
AS
BEGIN
	SET NOCOUNT ON
	
	DROP TABLE IF EXISTS #SentimentResultDefault
	CREATE TABLE #SentimentResultDefault(
	analysisType VARCHAR(50),
	intentId VARCHAR(50),
	score NUMERIC(10,5),
	[status] INT
	
	)

	 IF EXISTS(SELECT 1 FROM [dbo].[SentimentAnalysisResult] SAR WHERE SAR.[VCC] = @VCC
				AND SAR.[InteractionId] = @InteractionId
				AND SAR.[InteractionSection] = @InteractionSection
				AND SAR.[InteractionPart] = @InteractionPart
				AND ISNULL(CONVERT(DATE, SAR.[EndDate], 105), '') = ISNULL(@EndDate, '') )
	BEGIN
	INSERT INTO  #SentimentResultDefault
		SELECT DISTINCT 'client', intentid, 0, 0 from intent where vcc = @VCC and AppId like '%sentiment-%'
		UNION
		SELECT DISTINCT 'agent', intentid, 0, 0 from intent where vcc = @VCC and AppId like '%sentiment-%'
		UNION
		SELECT DISTINCT 'general', intentid, 0, 0 from intent where vcc = @VCC and AppId like '%sentiment-%'

	END

	INSERT INTO #SentimentResultDefault
		SELECT [AnalysisType]					'analysisType',
				[SentimentId]					'intentId',
				[Score]							'averageResult',			
				[MaxScore]
			FROM [dbo].[SentimentAnalysisResult] SAR (NOLOCK)
	
			WHERE SAR.[VCC] = @VCC
					AND SAR.[InteractionId] = @InteractionId
					AND SAR.[InteractionSection] = @InteractionSection
					AND SAR.[InteractionPart] = @InteractionPart
					AND ISNULL(CONVERT(DATE, SAR.[EndDate], 105), '') = ISNULL(@EndDate, '')
	
	DROP TABLE IF EXISTS #SentimentResultDefaultMax
	
	SELECT analysisType,intentId,MAX(score) as 'score',MAX([status]) 'status'
		INTO  #SentimentResultDefaultMax
		FROM  #SentimentResultDefault
		GROUP BY analysisType,intentId
	
   
				
	SELECT [AnalysisType]				'analysisType',
		   [intentId]					'intentId',
		   [Score]						'averageResult',
		   CASE WHEN [status] = 0 THEN	'normal' 
				ELSE 'max' 
				END						'status'
			
		FROM #SentimentResultDefaultMax
    
    SET NOCOUNT OFF
END


PRINT N'Altering Procedure [dbo].[GetEvaluationResultEfectivitySummary]...';

GO

ALTER PROCEDURE [dbo].[GetEvaluationResultEfectivitySummary](
		@VCC VARCHAR(50),
		@EfectivityPlanId VARCHAR(50)
)
AS
BEGIN
		CREATE TABLE #TEMP_EVALUATIONREF(
		VCC	VARCHAR(50),		
		IdInteraction VARCHAR(250),
		IdEvaluationPlan VARCHAR(50),
		ScoreDescription VARCHAR(20),	
		Efectivity	VARCHAR(10),
		Title	VARCHAR(200),
		
		)

		INSERT INTO #TEMP_EVALUATIONREF
			SELECT DISTINCT ERE.[VCC],ER.[IdInteraction],ER.[IdEvaluationPlan],ER.[ScoreDescription],ERE.[Efectivity]
			,A.[Title] 
			FROM dbo.[EvaluationResult] ER (NOLOCK)
			INNER JOIN dbo.[EvaluationResultEfectivity] ERE (NOLOCK)
 
			ON ERE.[VCC] = ER.[Instance]
			AND ERE.[InteractionId] = ER.[IdInteraction]
			AND ERE.[AgentId] = ER.[IdAgent]
			AND ERE.[EvaluationPlanId] = ER.[IdEvaluationPlan] 
			AND ERE.[AbilityEvaluationFormatId] = ER.[IdAbilityEvaluationFormat]		
			INNER JOIN dbo.[Ability] A ON 
			ER.[IdAbility] = A.[ID]
			AND ER.[Instance] = A.[Instance]
			WHERE
			 ER.[Instance] = @VCC		
			 AND ERE.[EfectivityPlanId] = @EfectivityPlanId
		
	

		SELECT DISTINCT IdInteraction  
			INTO #TEMP_EVALUATIONREF_I
			FROM #TEMP_EVALUATIONREF
			WHERE Efectivity IS NOT NULL

		DECLARE @nroInteracciones INTEGER
		SELECT  @nroInteracciones = COUNT(IdInteraction) FROM #TEMP_EVALUATIONREF_I 

		SELECT [VCC] 'vcc',[title] 'ability',
		ISNULL(SUM(CASE WHEN [Efectivity] = 1 THEN 1 ELSE 0 END),0) AS 'correcto' ,
		ISNULL(SUM(CASE WHEN [Efectivity] = 0 THEN 1 ELSE 0 END ),0) AS 'incorrecto' ,
		@nroInteracciones 'nroInteracciones'
		FROM #TEMP_EVALUATIONREF
		GROUP BY  VCC,title


END
