PRINT N'Quitando Índice [dbo].[AuditorEvaluationPlan].[IX_AuditorEvaluationPlan]...';


GO
DROP INDEX [IX_AuditorEvaluationPlan]
    ON [dbo].[AuditorEvaluationPlan];


GO
PRINT N'Modificando Tabla [dbo].[AuditorEvaluationPlan]...';


GO
ALTER TABLE [dbo].[AuditorEvaluationPlan] ALTER COLUMN [ManagementResult] VARCHAR (500) NULL;


GO
PRINT N'Creando Índice [dbo].[AuditorEvaluationPlan].[IX_AuditorEvaluationPlan]...';


GO
CREATE NONCLUSTERED INDEX [IX_AuditorEvaluationPlan]
    ON [dbo].[AuditorEvaluationPlan]([Instance] ASC, [IdAuditor] ASC, [IdCampaign] ASC, [IdAgent] ASC, [InteractionType] ASC, [InteractionOrigin] ASC, [InteractionFormat] ASC, [ManagementResult] ASC);


GO
PRINT N'Modificando Procedimiento [dbo].[BulkAuditorEvaluationPlan]...';


GO
ALTER PROCEDURE [dbo].[BulkAuditorEvaluationPlan]
AS
BEGIN
	SET NOCOUNT ON

	/*
	SELECT * 
		INTO TMP_AUDITOR_EVALUATION_PLAN
		FROM [dbo].[#AuditorEvaluationPlanTemp]
		
	SELECT *
		INTO #AuditorEvaluationPlanTemp
		FROM TMP_AUDITOR_EVALUATION_PLAN
	

	-- SELECT * FROM TMP_AUDITOR_EVALUATION_PLAN
	-- SELECT * FROM dbo.[#AuditorEvaluationPlanTemp]
	RAISERROR('DATABASE_ERROR_DEBUGGING', 16, 16)
	*/

	-- ACTUALIZAMOS LOS REGISTROS QUE YA EXISTAN BD
	UPDATE AEP
		SET AEP.[InteractionOrigin] = TMP_AEP.[InteractionOrigin],
			AEP.[InteractionFormat] = TMP_AEP.[InteractionFormat],
			AEP.[ContactId] = TMP_AEP.[InteractionContactId],
			AEP.[LastModifiedDate] = GETUTCDATE(),
			AEP.[TimeStamp] = GETUTCDATE()
		FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
		INNER JOIN [#AuditorEvaluationPlanTemp] TMP_AEP
			ON AEP.[Instance] = TMP_AEP.[VCC]
				AND TMP_AEP.[EvaluationPlanId] = AEP.[IdEvaluationPlan]
				AND TMP_AEP.[AuditorId] = AEP.[IdAuditor]
				AND TMP_AEP.[InteractionId] = AEP.[IdInteraction]
				AND TMP_AEP.[AgentId] = AEP.[IdAgent]
				AND TMP_AEP.[InteractionType] = AEP.[InteractionType]

	-- VOLCAMOS LOS REGISTROS QUE NO EXISTAN EN LA BD
	;WITH CTE_NEW_AUDITOR_EVALUATION_PLAN AS (
		SELECT TMP_AEP.* 
			FROM [#AuditorEvaluationPlanTemp] TMP_AEP
			LEFT JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				ON AEP.[Instance] = TMP_AEP.[VCC]
					AND AEP.[IdEvaluationPlan] = TMP_AEP.[EvaluationPlanId]
					AND AEP.[IdAuditor] = TMP_AEP.[AuditorId]
					AND AEP.[IdInteraction] = TMP_AEP.[InteractionId]
					AND AEP.[IdAgent] = TMP_AEP.[AgentId]
					AND AEP.[InteractionType] = TMP_AEP.[InteractionType]
			WHERE AEP.[Instance] IS NULL 
	)
		-- INSERTMAOS LA DATA EN LA TABLA AEP
		INSERT INTO [dbo].[AuditorEvaluationPlan] (
				[Instance], [IdEvaluationPlan], [idCampaign], [IdAgent], [IdAuditor],
				[IdInteraction], [InteractionType], [InteractionDate], [InteractionDateEnd], [InteractionDuration],
				[ManagementResult], [InteractionOrigin], [InteractionFormat], [ContactId], [ContactAddress], 
				[ContactName], [Status], [StatusDescription], [Completed], [Score],
				[CreatedByUserId], [CreatedDate], [TimeStamp]
			)
			SELECT CTE_AEP.[VCC], CTE_AEP.[EvaluationPlanId], ISNULL(CTE_AEP.[CampaignId], ''), CTE_AEP.[AgentId], CTE_AEP.[AuditorId],
					CTE_AEP.[InteractionId], CTE_AEP.[InteractionType], CTE_AEP.[InteractionStartDate], CTE_AEP.[InteractionEndDate], CTE_AEP.[InteractionDuration],
					CTE_AEP.[InteractionManagementResult], CTE_AEP.[InteractionOrigin], CTE_AEP.[InteractionFormat], CTE_AEP.[InteractionContactId], CTE_AEP.[InteractionContactAddress],
					CTE_AEP.[InteractionContactName], 1, 'NEW', 0, 0,
					'system', GETUTCDATE(), GETUTCDATE()
				FROM CTE_NEW_AUDITOR_EVALUATION_PLAN CTE_AEP 


	-- ELIMINAMOS LA TABLA TEMPORAL 
	DROP TABLE [#AuditorEvaluationPlanTemp]
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando Procedimiento [dbo].[SaveInteractionEvaluationPlanResult]...';


GO
ALTER PROCEDURE [dbo].[SaveInteractionEvaluationPlanResult] (
	@VCC VARCHAR(50),
	@IdEvaluationPlan VARCHAR(50),
	@IdAuditor VARCHAR(50),
	@IdInteraction VARCHAR(250),
	@InteractionType VARCHAR(50),
	@Score NUMERIC(5,2),
	@AutomaticScore NUMERIC(5,2),
	@ManualScore NUMERIC(5,2),
	@IsDraft BIT
) AS
BEGIN
	SET NOCOUNT ON

	-- EN CASO LLEGUE NULL ASIGNAMOS UN VALOR
	IF @IsDraft IS NULL
		SET @IsDraft = 0

 	UPDATE [dbo].[AuditorEvaluationPlan] 
		SET [Completed] = IIF (@IsDraft = 1, 0, 1), 
			[Score] = @Score, 
			[AutomaticScore] = @AutomaticScore,
			[ManualScore] = @ManualScore,
			[StatusDescription] = IIF (@IsDraft = 1, 'DRAFT', 'COMPLETED'),
			[LastModifiedDate] = GETUTCDATE(),
			[TimeStamp] = GETUTCDATE()
		WHERE [Instance] = @VCC
			AND [IdEvaluationPlan] = @IdEvaluationPlan
			AND [IdInteraction] = @IdInteraction
			AND [InteractionType] = @InteractionType
			AND [IdAuditor] = @IdAuditor

	-- ACTUALIZAMOS LAS NOTAS FINALES TENIENDO EN CUENTA LAS PENALIZACIONES
	IF @IsDraft = 0
	BEGIN
		;WITH CTEFP AS (
			SELECT DISTINCT 
					ER.[Instance],
					ER.[IdInteraction],
					ER.[IdEvaluationPlan],
					ER.[IdEvaluationFormat],
					ER.[IdAbility],
					CASE WHEN ER.[AbilityInnerScore] = 0 AND HAEF.[Penalizes] <> 'NO' THEN 1 ELSE 0 END 'Penalized',
					HAEF.[Penalizes],
					CASE HAEF.[Penalizes]
						WHEN 'INT' THEN ER.[IdInteraction] 
						WHEN 'GRP' THEN ER.[IdGroup] 
						WHEN 'SGR' THEN ER.[IdSubGroup] 
					END 'PenalizedOn',
					RN = ROW_NUMBER() OVER(PARTITION BY ER.[IdInteraction], CASE WHEN ER.[AbilityInnerScore] = 0 THEN 1 ELSE 0 END 
						ORDER BY CASE HAEF.[Penalizes]
						WHEN 'INT' THEN 1 
						WHEN 'GRP' THEN 2 
						WHEN 'SGR' THEN 3 
					END)
				FROM [EvaluationResult] ER (NOLOCK) 
				LEFT JOIN [HistoricAbilityEvaluationFormat] HAEF (NOLOCK) 
					ON HAEF.[VCC] = ER.[Instance]
						AND HAEF.[EvaluationPlanId] = ER.[IdEvaluationPlan]
						AND HAEF.[IdEvaluationFormat] = ER.[IdEvaluationFormat]
						AND HAEF.[IdAbility] = ER.[IdAbility]
				WHERE ER.[IdEvaluationPlan] IN (@IdEvaluationPlan) 
					AND ER.[IdInteraction] = @IdInteraction
					AND ER.[IdAuditor] = @IdAuditor
					AND ER.[AbilityInnerScore] = 0
					AND HAEF.[Penalizes] <> 'NO'
				-- WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EPA.[EvaluationPlanId] FROM [DummyEvaluationPlanAbility] EPA (NOLOCK) WHERE EPA.[EvaluationPlanId] IS NOT NULL)
		),
		CTEFS AS (
			SELECT ER.[Instance],
					ER.[IdEvaluationPlan],
					ER.[IdInteraction],
					ER.[IdAuditor],
					SUM(ER.[Qualification])															'TOTAL_SCORE',
					SUM(IIF(HA.[Type] = 'MANUAL_AUTOMATIC', ER.[Qualification], 0))					'TOTAL_AUTOMATIC_SCORE',
					SUM(IIF(HA.[Type] = 'MANUAL', ER.[Qualification], 0))							'TOTAL_MANUAL_SCORE',
					--SUM(ER.[Qualification] * CASE WHEN FP2.[Penalized] IS NULL THEN 1 ELSE 0 END) 'PENALIZED_SCORE',
					SUM(ER.[Qualification] * (
						CASE WHEN (
							CASE FP2.[Penalizes]
								WHEN 'INT' THEN ER.[IdInteraction] 
								WHEN 'GRP' THEN ER.[IdGroup] 
								WHEN 'SGR' THEN ER.[IdSubGroup] 
							END = FP2.[PenalizedOn]
							AND FP2.[Penalized] = 1) THEN 0 ELSE 1 END
					))																				'PENALIZED_SCORE',
					SUM(IIF(HA.[Type] = 'MANUAL_AUTOMATIC',
						ER.[Qualification] * (
						CASE WHEN (
							CASE FP2.[Penalizes]
								WHEN 'INT' THEN ER.[IdInteraction] 
								WHEN 'GRP' THEN ER.[IdGroup] 
								WHEN 'SGR' THEN ER.[IdSubGroup] 
							END = FP2.[PenalizedOn]
							AND FP2.[Penalized] = 1
						) THEN 0 ELSE 1 END),
						0) 
					)																				'PENALIZED_AUTOMATIC_SCORE',
					SUM(IIF(HA.[Type] = 'MANUAL',
						ER.[Qualification] * (
						CASE WHEN (
							CASE FP2.[Penalizes]
								WHEN 'INT' THEN ER.[IdInteraction] 
								WHEN 'GRP' THEN ER.[IdGroup] 
								WHEN 'SGR' THEN ER.[IdSubGroup] 
							END = FP2.[PenalizedOn]
							AND FP2.[Penalized] = 1
						) THEN 0 ELSE 1 END),
						0) 
					)																				'PENALIZED_MANUAL_SCORE'
				FROM EvaluationResult ER (NOLOCK) 
				LEFT JOIN (
					-- HACEMOS UN CRUCE CON LA TABLA VARIABLE Y TOMAMOS SOLO UNA DE LAS PENALIZACIONES POR INTERACCION, EMPEZANDO 
					--  POR LA MAS PRIORITARIA (FP.[RN])
					SELECT DISTINCT FP.[Instance],
									FP.[IdEvaluationPlan], 
									FP.[IdInteraction], 
									FP.[Penalized],
									FP.[Penalizes], 
									FP.[PenalizedOn]
						FROM CTEFP FP (NOLOCK)
						WHERE FP.[Penalizes] <> 'NO'
							AND FP.[RN] = 1
				) FP2
					ON FP2.[Instance] = ER.[Instance]
						AND ER.[IdEvaluationPlan] = FP2.[IdEvaluationPlan]
						AND ER.[IdInteraction] = FP2.[IdInteraction]
						/*
						AND CASE FP2.[Penalizes]
								WHEN 'INT' THEN ER.[IdInteraction] 
								WHEN 'GRP' THEN ER.[IdGroup] 
								WHEN 'SGR' THEN ER.[IdSubGroup] 
							END = FP2.[PenalizedOn]
						AND FP2.[Penalized] = 1
						*/
				INNER JOIN dbo.[HistoricAbility] HA (NOLOCK)
					ON HA.[VCC] = ER.[Instance]
						AND HA.[EvaluationPlanId] = ER.[IdEvaluationPlan]
						AND HA.[ID] = ER.[IdAbility]
				--WHERE ER.[Instance] = 'multisalud'
				WHERE -- ER.[Instance] = FP2.[Instance] -- ESTA LINEA CAUSA QUE NO SE ACTUALICEN LOS SCORES LAS EVALUACIONES QUE NO PENALIZAN
					-- AND 
					ER.[IdEvaluationPlan] IN (@IdEvaluationPlan) 
					AND ER.[IdInteraction] = @IdInteraction
					AND ER.[IdAuditor] = @IdAuditor
					--AND ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM DummyEvaluationPlanAbility)
				GROUP BY ER.[Instance],
					ER.[IdEvaluationPlan],
					ER.[IdInteraction],
					ER.[IdAuditor]
		)
		--SELECT * FROM CTEFS

		-- ACTUALIZAMOS LOS REGISTROS DE EVALUACION CON LA NOTA PENALIZADA OBTENIDA EN LOS PASOS ANTERIORES
		UPDATE AEP 
			SET AEP.[Score] = FS.[PENALIZED_SCORE],
				AEP.[AutomaticScore] = FS.[PENALIZED_AUTOMATIC_SCORE],
				AEP.[ManualScore] = FS.[PENALIZED_MANUAL_SCORE],
				AEP.[LastModifiedDate] = GETUTCDATE(),
				AEP.[TimeStamp] = GETUTCDATE()
			FROM AuditorEvaluationPlan AEP (NOLOCK)
			LEFT JOIN CTEFS FS (NOLOCK) 
				ON FS.[Instance] = AEP.[Instance] 
					AND FS.[IdEvaluationPlan] = AEP.[IdEvaluationPlan] 
					AND FS.[IdInteraction] = AEP.[IdInteraction]
					AND FS.[IdAuditor] = AEP.[IdAuditor]
			WHERE FS.[Instance] IS NOT NULL
	END

    SELECT 1 AS 'result'

 	SET NOCOUNT OFF
END
GO
PRINT N'Modificando Procedimiento [dbo].[ReportByDetailAgent]...';


GO
ALTER PROCEDURE [dbo].[ReportByDetailAgent] (
	@VCC varchar(50) = NULL, 
	@HistoricCampaign varchar(MAX) = NULL , 
	@Plan varchar(MAX) = NULL,
	@Format varchar(MAX), 
	@StartDate DateTime = NULL , 
	@EndDate DateTime = NULL , 
	@IdAuditor varchar(MAX) = NULL ,
	@IdAgente varchar(MAX) = NULL
) AS
BEGIN
	-- ReportByDetailAgent 'allegro','entrantes','Plan_2_nov01-0356','nov01-0356','20191001','20191201','isidoro','icagente3'
	SET NOCOUNT ON
	
	DECLARE @cols varchar(max) 
	DECLARE @query varchar(max)
  
	-- SETTEAMOS EL STARTDATE Y ENDDATE EN CASO SEAN NULL
	IF @StartDate IS NULL SET @StartDate = '2021-01-01 00:00:00'
	IF @EndDate IS NULL SET @EndDate = '2050-01-01 23:59:59' 
	ELSE 
	BEGIN
		SET @EndDate = DateAdd(hh,- (DatePart(hh, @EndDate)) + 23, @EndDate) 
		SET @EndDate = DateAdd(mi,- (DatePart(mi, @EndDate)) + 59, @EndDate) 
		SET @EndDate = DateAdd(ss,- (DatePart(ss, @EndDate)) + 59, @EndDate) 
	END

	SELECT * 
		INTO #TempEvaluationResult
		FROM (
			SELECT EP.[Instance]														'VCC',
					EP.[Description]													'DescriptionPlan',
					EF.[Description]													'DescriptionFormat',
					(
						GP.[Description]
						+ '-' 
						+ SGP.[Description]
						+ '-' 
						+ A.[Title]
					)																	'Ability', --Collate SQL_Latin1_General_CP1253_CI_AI
					ER.[AgentDescription],
					ER.[CampaignDescription],
					ER.[IdInteraction],
					ISNULL(ER.[Qualification], 0)										'Qualification',
					AEP.[Score]															'Score',
					AEP.[AutomaticScore],
					AEP.[ManualScore],
					--Format(ER.EvaluationDate, 'dd/MM/yyyy hh:mm:ss')					AS 'EvaluationDate',
					--CAST(Format(AEP.[TimeStamp], 'yyyy-MM-dd hh:mm:ss') AS DATETIME)					AS 'EvaluationDate',
					AEP.[TimeStamp] AS 'EvaluationDate',
					ER.[IdAuditor],
					EP.[Evaluation_Mode]
				FROM dbo.[EvaluationResult] (NOLOCK) ER
				INNER JOIN dbo.[HistoricEvaluationFormat] EF
					ON EF.[VCC] = ER.[Instance]
						AND EF.[EvaluationPlanId] = ER.[IdEvaluationPlan] 
						AND EF.ID = ER.[IdEvaluationFormat] 
				INNER JOIN dbo.[HistoricAbility] (NOLOCK) A
					ON A.[VCC] = ER.[Instance]
						AND A.[EvaluationPlanId] = ER.[IdEvaluationPlan]  
						AND A.[ID] = ER.[IdAbility] 
				INNER JOIN dbo.[EvaluationPlan] (NOLOCK) EP
					ON EP.[Instance] = ER.[Instance]
						AND EP.[ID] = ER.[IdEvaluationPlan]
				INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) 
					ON AEP.[Instance] = ER.[Instance]
						AND AEP.[IdEvaluationPlan] =  ER.[IdEvaluationPlan]
						AND AEP.[IdInteraction] = ER.[IdInteraction]
						AND AEP.[IdAuditor] =  ER.[IdAuditor]
				INNER JOIN [HistoricGroup] (NOLOCK) GP
					ON GP.[VCC] = ER.[Instance]
						AND GP.[EvaluationPlanId] = EP.ID
						AND GP.[ID] = ER.[IdGroup] 
				INNER JOIN dbo.[HistoricSubGroup] (NOLOCK) SGP
					ON SGP.[VCC] = ER.[Instance]
						AND SGP.[EvaluationPlanId] = EP.[ID]
						AND SGP.[ID] = ER.[IdSubGroup] 
				WHERE ER.[IdEvaluationPlan] IN (SELECT [Value] FROM [dbo].[Split](IIF(@Plan IS NULL, EP.[Description], @Plan), ','))
					AND AEP.[TimeStamp] BETWEEN @StartDate AND  @EndDate
					AND AEP.[Completed] = 1
					AND AEP.[StatusDescription] NOT IN('INVALID')
					AND ER.[Instance] LIKE CASE WHEN @VCC IS NOT NULL THEN @VCC ELSE ER.[Instance] END
					AND ER.[AgentDescription] IN (SELECT [Value] FROM [dbo].[Split](IIF(@IdAgente IS NULL, ER.[AgentDescription], @IdAgente), ','))
					AND ER.[IdAuditor] IN (SELECT [Value] FROM [dbo].[Split](IIF(@IdAuditor IS NULL, ER.[IdAuditor], @IdAuditor), ','))
					AND ER.[CampaignDescription] IN (SELECT [Value] FROM [dbo].[Split](IIF(@HistoricCampaign IS NULL, ER.[CampaignDescription], @HistoricCampaign), ','))
					AND EF.[Description] IN (SELECT [Value] FROM [dbo].[Split](IIF(@Format IS NULL, EF.[Description], @Format), ','))
					--AND EP.[Status] = 7
		) A

	-- print 'Despues del select'

	--select * from #TempEvaluationResult ORDER BY IdInteraction

	
	SET @cols = STUFF(
		(
			SELECT (',' + QUOTENAME(TMP_ER.[Ability]))
				FROM #TempEvaluationResult TMP_ER
				GROUP BY TMP_ER.[Ability] 
				ORDER BY TMP_ER.[Ability] 
			FOR xml PATH (''), TYPE
		).value('.', 'varchar(Max)')
		, 1, 1, '')

  --Select @cols
  IF @cols IS NOT NULL
  BEGIN

    DECLARE @type varchar(max)=(Select Top 1 Evaluation_Mode From #TempEvaluationResult)

    DECLARE @Total varchar(max) = STUFF(
		(
			SELECT '+ ISNULL(' + QUOTENAME(TMP_ER.[Ability]) + ',0)'
				FROM #TempEvaluationResult TMP_ER
				GROUP BY TMP_ER.[Ability] 
				ORDER BY TMP_ER.[Ability] 
			FOR xml PATH (''), TYPE
		).value('.', 'varchar(Max)')
		, 1, 1, '')

    --SELECT @type
	If @type = 'M'
	BEGIN
    SET @query = ' 
				SELECT p.[VCC]							[VCC],
						p.[DescriptionPlan]				[EVALUATION_PLAN],
						p.[DescriptionFormat]			[EVALUATION_FORMAT],
						p.[AgentDescription]			[AGENT],
  						p.[CampaignDescription]			[CAMPAIGN],
						p.[IdInteraction]				[INTERACTION],
						p.[EvaluationDate]				[EVALUATION_DATE],
						p.[IdAuditor]					[AUDITOR],
						[InteractionDuration]			[DURATION_TIME], 
						NULL							[PHONE],
						[InteractionDateStart]			[START_DATE],
						NULL							[CATEGORY],
						-- (' + @Total + ')				[COLUMN_TOTAL_SCORE], 
						p.[Score]						[COLUMN_TOTAL_SCORE], 
						p.[AutomaticScore]				[COLUMN_AUTOMATIC_SCORE],
						p.[ManualScore]					[COLUMN_MANUAL_SCORE],
						' + @cols + ' 
					FROM 
				( select VCC,
							DescriptionPlan,
							DescriptionFormat,
							Ability,
							AgentDescription,
							CampaignDescription,
							IdInteraction,
							EvaluationDate,
							Qualification,
							Score,
							AutomaticScore,
							ManualScore,
							IdAuditor			
						from #TempEvaluationResult
			   ) x
				pivot 
				( 
					 max(Qualification)
					for Ability in (' + @cols + ')
				) p 
				Left Join (
				Select Distinct IdInteraction,InteractionDuration,InteractionDateStart From InteractionEvaluationPlan (Nolock) 
				) as A On
				A.IdInteraction = p.IdInteraction '
    END
	ELSE 
	BEGIN
    SET @query = ' 
				Select p.[VCC]							[VCC],
						p.[DescriptionPlan]				[EVALUATION_PLAN],
						p.[DescriptionFormat]			[EVALUATION_FORMAT],
						p.[AgentDescription]			[AGENT],
  						p.[CampaignDescription]			[CAMPAIGN] ,
						p.[IdInteraction]				[INTERACTION] ,
						p.[EvaluationDate]				[EVALUATION_DATE],
						p.[IdAuditor]					[AUDITOR],
						A.[DurationTime]				[DURATION_TIME],
						A.[Number]						[PHONE] ,
						A.[StartDate]					[START_DATE] ,
						A.[Category1]					[CATEGORY] ,
						-- (' + @Total + ')				[COLUMN_TOTAL_SCORE], 
						p.[Score]						[COLUMN_TOTAL_SCORE], 
						p.[AutomaticScore]				[COLUMN_AUTOMATIC_SCORE],
						p.[ManualScore]					[COLUMN_MANUAL_SCORE],
						' + @cols + ' 
					from ( 
						select VCC,
								DescriptionPlan,
								DescriptionFormat,
								Ability,
								AgentDescription,
								CampaignDescription,
								IdInteraction,
								EvaluationDate,
								Qualification,
								Score,
								AutomaticScore,
								ManualScore,
								IdAuditor			
							from #TempEvaluationResult
					) x pivot 
					( 
						 max(Qualification)
						for Ability in (' + @cols + ')
					) p 
					LEFT Join Audio as A 
						On A.[VCC] = p.[VCC]
							AND A.ID = p.IdInteraction'
	END
	--Print(@query)
    EXECUTE (@query)
    DROP TABLE #TempEvaluationResult
  END
  ELSE
  BEGIN
    SELECT
						''				As [EVALUATION_PLAN],
						''				As [EVALUATION_FORMAT],
						''				As [AGENT],
  						''			    As [CAMPAIGN] ,
						''			 	As [INTERACTION] ,
						''				As [EVALUATION_DATE],
						''				As [AUDITOR]
  END
  
  SET NOCOUNT OFF

END
GO
PRINT N'Modificando Procedimiento [dbo].[BulkAudio]...';


GO
ALTER PROCEDURE [dbo].[BulkAudio]
AS
BEGIN
	-- DECLARAMOS UNA VARIABLE PARA DEFINIR EL VCC
	DECLARE @VCC VARCHAR(50) = NULL
	DECLARE @VCC_TYPE VARCHAR(50) = NULL

	-- ASIGNAMOS A LA VARIABLE EL NOMBRE DEL VCC
	SELECT TOP 1 @VCC = [VCC] FROM #AudioTemp (NOLOCK)

	-- BUSCAMOS EL TIPO DE VCC
	SELECT @VCC_TYPE = V.[Type] FROM [dbo].[VCC] V (NOLOCK) WHERE V.[VCC] = @VCC

	-- ACTUALIZAR RELATIVE PATH
	UPDATE A
		SET A.[RelativePath] = ATE.[RelativePath],
			A.[RelativeFileName] = ATE.[RelativeFileName]
		FROM dbo.[AUDIO] A
		INNER JOIN #AudioTemp ATE 
			ON A.[VCC] = ATE.[VCC] 
				AND A.[ID] = ATE.[ID]
				AND A.[Section] = ATE.[Section] 
				AND A.[Part] = ATE.[Part]
		WHERE A.[IsCancel] = 1

	-- EMULAMOS UNA NUEVA TABLA EN BASE A #AudioTemp DONDE SE REMOVERAN TODOS LOS REGISTROS DUPLICADOS PARA EL PK DE LA TABLA Audio
	;WITH CTE AS (
		SELECT A.[VCC], A.[ID], A.[Section], A.[Part], A.[Number],
				A.[Gender], A.[SilenceTime], A.[DurationTime], A.[Category1], A.[Category2],
				A.[Category3], A.[Description], A.[Campaign], A.[Agent], ISNULL(A.[AgentName], AG.[Name]) 'AgentName',
				A.[Type], A.[Init], A.[StartDate], A.[EndDate], A.[DispositionCode], 
				A.[RelativePath], A.[FileName], A.[CreatedDate], A.[CreatedByUserId], A.[LastModifiedDate], 
				A.[LastModifiedByUserId], A.[ContactId], A.[ContactName], A.[ContactAddress],A.[NeedI6Update],A.[RelativeFileName], 
				RN = ROW_NUMBER() OVER(PARTITION BY A.[VCC], A.[ID], A.[Section], A.[Part] ORDER BY A.[ID])
			FROM #AudioTemp A (NOLOCK)
			LEFT JOIN [dbo].[Agent] AG (NOLOCK)
				ON AG.[VCC] = A.[VCC]
					AND AG.[AgentId] = A.[Agent]
	)
	-- LA TABLA TEMPORAL #AudioTemp LLEGA CON ALGUNOS REGISTROS DUPLICADOS DEBIDO A LOS CRUCES AL APLICAR LOR FILTROS, POR ELLO DEBEMOS 
	-- IDENTIFICAR LOS REPETIDOS, RN = ROW_NUMBER() OVER(PARTITION BY ...) <- NUMERA CADA REGISTRO SEGUN EL(LOS) VALOR(ES) DE ...

	-- EL CTE SOLO PUEDE SER INVOCADO UNA VEZ POR ESO LO PONEMOS EN EL SELECT FINAL DONDE EL CONTADOR(RN) ES 1
	--DELETE FROM CTE WHERE RN > 1
	

	INSERT INTO dbo.Audio(
			[VCC]
			,[ID]
			,[Section]
			,[Part]
			,[Number]
			,[Gender]
			,[SilenceTime]
			,[DurationTime]
			,[Category1]
			,[Category2]
			,[Category3]
			,[Description]
			,[Campaign]
			,[Agent]
			,[AgentName]
			,[Type]
			,[Init]
			,[NeedI6Update]
			,[StartDate]
			,[EndDate]
			,[DispositionCode]
			,[RelativePath]
			,[FileName]
			,[CreatedDate]
			,[CreatedByUserId]
			,[LastModifiedDate]
			,[LastModifiedByUserId]
			,[TimeStamp]
			,[ContactId]			
			,[ContactName]
			,[ContactAddress]
			,[RelativeFileName]
			) 
		SELECT
			 A.[VCC]
			,A.[ID]
			,A.[Section]
			,A.[Part]
			,A.[Number]
			,A.[Gender]
			,A.[SilenceTime]
			,A.[DurationTime]
			,A.[Category1]
			,A.[Category2]
			,A.[Category3]
			,A.[Description]
			,A.[Campaign]
			,A.[Agent]
			,A.[AgentName]
			,A.[Type]
			,A.[Init]
			,A.[NeedI6Update]
			,A.[StartDate]
			,A.[EndDate]
			,A.[DispositionCode]
			,A.[RelativePath]
			,A.[FileName]
			,A.[CreatedDate]
			,A.[CreatedByUserId]
			,A.[LastModifiedDate]
			,A.[LastModifiedByUserId]
			,GETUTCDATE()
			,A.[ContactId]		
			,A.[ContactName]
			,A.[ContactAddress]
			,A.[RelativeFileName]
		FROM CTE A (NOLOCK)
		WHERE A.RN = 1
			AND NOT EXISTS (
				SELECT * 
					FROM Audio B (NOLOCK)
					WHERE B.[VCC] = A.[VCC]
						AND B.[ID] = A.[ID]
						AND B.[Section] = A.[Section]
						AND B.[Part] = A.[Part]
			)
	




	-- EMULAMOS UNA NUEVA TABLA EN BASE A #AudioTemp DONDE SE REMOVERAN TODOS LOS REGISTROS DUPLICADOS PARA EL PK DE LA TABLA Audio
	;WITH CTE_PAT AS (
	   SELECT PAT.[VCC], PAT.[ProcessId], PAT.[AudioId], PAT.[Section], PAT.[Part]
			,PAT.[CreatedDate], PAT.[CreatedByUserId], PAT.[LastModifiedDate], PAT.[LastModifiedByUserId], RN = ROW_NUMBER() OVER(PARTITION BY PAT.[VCC], PAT.[ProcessId], PAT.[AudioId], PAT.[Section], PAT.[Part] ORDER BY PAT.[AudioId])
	   FROM #ProcessAudioTemp PAT (NOLOCK)
	)
	-- EL CTE_PAT SOLO PUEDE SER INVOCADO UNA VEZ POR ESO LO PONEMOS EN EL SELECT FINAL DONDE EL CONTADOR(RN) ES 1
	--DELETE FROM CTE_PAT WHERE RN > 1
		
	-- Insertamos registros en la tabla ProcessAudio
	INSERT INTO dbo.ProcessAudio
			([VCC]
			,[ProcessId]
			,[AudioId]
			,[Section]
			,[Part]
			,[CreatedDate]
			,[CreatedByUserId]
			,[LastModifiedDate]
			,[LastModifiedByUserId]
			,[TimeStamp]
			) 
		SELECT PAT.[VCC]
			,PAT.[ProcessId]
			,PAT.[AudioId]
			,PAT.[Section]
			,PAT.[Part]
			,PAT.[CreatedDate]
			,PAT.[CreatedByUserId]
			,PAT.[CreatedDate]
			,PAT.[CreatedByUserId]
			,GETUTCDATE()
		FROM CTE_PAT PAT (NOLOCK)
		WHERE PAT.RN = 1
			AND NOT EXISTS (
			SELECT * FROM ProcessAudio PA (NOLOCK)
			WHERE PA.[VCC] = PAT.[VCC]
			AND PA.[ProcessId] = PAT.[ProcessId]
			AND PA.[AudioId] = PAT.[AudioId]
			AND PA.[Section] = PAT.[Section]
			AND PA.[Part] = PAT.[Part]
		)
		GROUP BY 
			PAT.[VCC]
			,PAT.[ProcessId]
			,PAT.[AudioId]
			,PAT.[Section]
			,PAT.[Part]
			,PAT.[CreatedByUserId]
			,PAT.[CreatedDate]

		DROP TABLE #AudioTemp
		DROP TABLE #ProcessAudioTemp

END
GO
PRINT N'Modificando Procedimiento [dbo].[GetAllegroInteractions]...';


GO
ALTER PROCEDURE [dbo].[GetAllegroInteractions] (
	@Ip						VARCHAR(50),
	@VCC					VARCHAR(50),
	@StartDate				DATETIME = NULL,
	@EndDate				DATETIME = NULL,
	@StartHour				VARCHAR(50),
	@EndHour				VARCHAR(50),
	@Campaign				VARCHAR(MAX),
	@Agent					VARCHAR(MAX),
	@ResultCode				VARCHAR(MAX),
	@Type					INT,
	@Origin					VARCHAR(MAX),
	@MinDuration			INT,
	@MaxDuration			INT,
	@Format					VARCHAR(50) = NULL, 
	@InteractionIds         VARCHAR(MAX) = NULL, 
	@Evaluated              VARCHAR(MAX) = NULL,
	-- @UniqueIds				BIT = 0,							-- ESTE FLAG TIENE COMO PROPOSITO RETORNAR LA LISTA CONSOLIDAD POR IDS O EL TOTAL DEL LISTADO (AUDIOS/INTERACTIONS)
	@ResultType				VARCHAR(50) = NULL,						-- VARIABLE PARA DETERMINAR SI LA BUSQUEDA SERA SOBRE SOBRE DETALLES O ID (DETAILED, SUMMARIZED)
	@ContactAddress			VARCHAR(300) = NULL
) AS
BEGIN
	-- SETTEAMOS UN VALOR POR DEFECTO AL FORMAT
	IF @Format IS NULL OR @Format = '' SET @Format = 'mp3,wav'

	-- SETTEAMOS VALORES MINIMOS PARA LAS HORAS DE INICIO Y FIN
	IF (@StartHour IS NOT NULL AND @StartHour = '') SET @StartHour = '00:00:00'
	IF (@EndHour IS NOT NULL AND @EndHour = '') SET @EndHour = '23:59:59'

	-- DECLARAMOS UNA VARIABLE PARA IDENTIFICAR SI EL SP ES LLAMADO DEL SISTEMA O POR OTRO SP
	DECLARE @IS_NESTED BIT = 0

	-- CREAMOS LAS VARIABLES QUE HARAN REFERENCIA A LAS TABLAS QUE PUEDEN SER EXTERNAS
	DECLARE @TABLE_HISTORICAL_DATA VARCHAR(50) = ''
	DECLARE @TABLE_MMPRODAT VARCHAR(50) = ''

	-- DECLARAMOS CADENAS PARA EL QUERY FINAL
	DECLARE @SQL_TMP VARCHAR(MAX) = ''
	DECLARE @SQL_CTE VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_SELECT VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_FROM_FIXED VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_FROM_OPTIONAL VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_FILTERS_FIXED VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_FILTERS_OPTIONAL VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_FILTERS_EXCLUDING VARCHAR(MAX) = ''
	
	DECLARE @Sql NVARCHAR(MAX)

	-- EL TYPE 0 INDICA QUE LAS TABLAS SE ENCUENTRAN EN UN SERVIDOR EXTERNO
	IF(@Type = 0)  
	BEGIN  
		SET @TABLE_HISTORICAL_DATA = '[' + @Ip + ']' + '.[HistoricalData].[dbo].'
		SET @TABLE_MMPRODAT = '[' + @Ip + ']' + '.[MMProDat].[dbo].'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @TABLE_HISTORICAL_DATA = '[HistoricalData].[dbo].'
		SET @TABLE_MMPRODAT = '[MMProDat].[dbo].'
	END
	
	IF(@Type = 0 OR @Type = 1)  
	BEGIN  
		-- VERIFICAMOS SI EXISTE LA TABLA TEMPORAL #TMP_HD_INTERACTIONS
		IF OBJECT_ID('TEMPDB..#TMP_HD_INTERACTIONS') IS NULL
		BEGIN
			-- CREAMOS UNA TABLA TEMPORAL PARA INSERTAR LOS REGISTROS DE LA HDI6
			CREATE TABLE #TMP_HD_INTERACTIONS
			(
				[ID] VARCHAR(150),
				[InteractionId] VARCHAR(100),
				[Section] INT,
				[Part] INT,
				[Channel] VARCHAR(50),
				[Number] VARCHAR(100),
				[Gender] VARCHAR(50),
				[SilenceTime] INT,
				[DurationTime] INT,
				[AttentionTime] INT,
				[Category1] VARCHAR(100),
				[Category2] VARCHAR(100),
				[Category3] VARCHAR(100),
				[Description] VARCHAR(150),
				[DispositionCode] INT,
				[Campaign] VARCHAR(150),
				[Agent] VARCHAR(100),
				[AgentName] VARCHAR(100),
				[Type] VARCHAR(100),
				[StartDate] VARCHAR(100),
				[EndDate] VARCHAR(100),
				[Format] VARCHAR(50),
				[ContactAddress] VARCHAR(300),
				[ContactId]  VARCHAR(50),
				[ContactName] VARCHAR(300),
				[RelativeFileName] VARCHAR(1000),
				[RNA] INT
			)

			-- REAFIRMAMOS QUE EL SP NO ESTA ANIDADO EN OTRO
			SET @IS_NESTED = 0
		END
		ELSE
		BEGIN
			-- SI LA TABLA TEMPORAL YA EXISTIA, EL SP ESTA ANIDADO EN OTRO (P.E.: [dbo].[GetAsyncBillingInteractions])
			SET @IS_NESTED = 1
		END 

		-- INICIAMOS ARMANDO LOS FILTROS PARA LA TABLA CTE PRINCIPAL
		SET @SQL_CTE_FILTERS_FIXED = '
				WHERE ID.[VirtualCC] = ''' + @VCC + '''
					AND ID.[EndDate] BETWEEN ''' + (SELECT CONVERT(VARCHAR(21), @StartDate, 127)) + ''' 
					AND ''' + (SELECT CONVERT(VARCHAR(21), @EndDate, 127)) + '''
					AND IMP.[Format] IN (SELECT Value FROM [dbo].[split](''' + @Format + ''','','')) '

		-- AGREGAMOS EL SCRIPT PARA LOS FILREOS DE HORA MAXIMA Y HORA MINIMA LAS CUALES TIENEN UN COMPORTAMIENTO DIFERENTES SEGUN CUAL ES MAYOR
		IF (CAST(@StartHour AS TIME) <= CAST(@EndHour AS TIME)) 
			SET @SQL_CTE_FILTERS_OPTIONAL += '
					AND CAST(ID.[EndDate] AS TIME) BETWEEN ''' + @StartHour + ''' AND ''' + @EndHour + ''' '
		IF (CAST(@StartHour AS TIME) > CAST(@EndHour AS TIME)) 
			SET @SQL_CTE_FILTERS_OPTIONAL += '
					AND CAST(ID.[EndDate] AS TIME) NOT BETWEEN ''' + @EndHour + ''' AND ''' + @StartHour + ''' '

		-- AGREGAMOS EL SCRIPT PARA EL FILTRO DE CAMPAIGN
		IF (@Campaign IS NOT NULL AND @Campaign <> '') 
		BEGIN
			-- DEBEMOS PASAR LA LISTA DE CAMPAIGNS A UNA TABLA TEMPORAL PARA AGILIZAR LA BUSQUEDA 
			SET @SQL_TMP += '
			SELECT * 
				INTO #FILTER_CAMPAIGNS
				FROM (
					SELECT Value FROM [dbo].[split](''' + @Campaign + ''','','')
				) A '

			-- AGREGAMOS EL JOIN EN LA BUSQUEDA PRINCIPAL
			SET @SQL_CTE_FROM_OPTIONAL += '  
				INNER JOIN #FILTER_CAMPAIGNS FC 
					ON FC.[Value] = ID.[Campaign] ' 
		END

		-- AGREGAMOS EL SCRIPT PARA EL FILTRO DE AGENT
		IF (@Agent IS NOT NULL AND @Agent <> '') 
		BEGIN
			-- DEBEMOS PASAR LA LISTA DE AGENTS A UNA TABLA TEMPORAL PARA AGILIZAR LA BUSQUEDA 
			SET @SQL_TMP += '
			SELECT * 
				INTO #FILTER_AGENTS
				FROM (
					SELECT Value FROM [dbo].[split](''' + @Agent + ''','','')
				) A '

			-- AGREGAMOS EL JOIN EN LA BUSQUEDA PRINCIPAL
			SET @SQL_CTE_FROM_OPTIONAL += '  
				INNER JOIN #FILTER_AGENTS FA 
					ON FA.[Value] = ISNULL(ID.[LastAgent], ID.[FirstAgent]) '
		END

		-- AGREGAMOS EL SCRPT PARA EL FILTRO ORIGEN
		IF (@Origin IS NOT NULL AND @Origin <> '') 
			SET @SQL_CTE_FILTERS_OPTIONAL += '
				AND ID.[Direction] IN (SELECT Value FROM [dbo].[split](''' + @Origin + ''','','')) '

		-- AGREGAMOS EL SCRIPT PARA LOS FILTROS DE DURACION MAXIMA Y HORA MINIMA LAS CUALES TIENEN UN COMPORTAMIENTO DIFERENTES SEGUN CUAL ES MAYOR
		IF (@MinDuration IS NOT NULL) 
			SET @SQL_CTE_FILTERS_OPTIONAL += '
				AND ID.[AttentionTime] >= ' + (SELECT CONVERT(varchar(10), @MinDuration)) + ' '
		IF (@MaxDuration IS NOT NULL) 
			SET @SQL_CTE_FILTERS_OPTIONAL += '
				AND ID.[AttentionTime] <= ' + (SELECT CONVERT(varchar(10), @MaxDuration)) + ' '

		-- AGREGAMOS EL SCRIPT PARA EL FILTRO CONTACT
		IF (@ContactAddress IS NOT NULL)
			SET @SQL_CTE_FILTERS_OPTIONAL += '
				AND ID.[ContactId] LIKE ''%' + @ContactAddress + '%'' '

		-- AGREGAMOS EL SCRIPT PARA INTERACTION_ID
		IF @InteractionIds IS NOT NULL AND @InteractionIds <> ''
		BEGIN
			SET @SQL_TMP = ''
			SET @SQL_CTE_FROM_OPTIONAL = ''
			SET @SQL_CTE_FILTERS_OPTIONAL = ''
			
			-- DEBEMOS PASAR LA LISTA DE CAMPAIGNS A UNA TABLA TEMPORAL PARA AGILIZAR LA BUSQUEDA 
			SET @SQL_TMP += '
			SELECT * 
				INTO #FILTER_INTERACTIONS_IDS
				FROM (
					SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')
				) A '
			-- AGREGAMOS EL JOIN EN LA BUSQUEDA PRINCIPAL
			SET @SQL_CTE_FROM_OPTIONAL += '  
				INNER JOIN #FILTER_INTERACTIONS_IDS FID 
					ON FID.[Value] = ID.[Id] ' 
			-- SET @SQL_CTE_FILTERS_EXCLUDING = ' AND ID.[Id] IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')) '
		END 


		-- ARMAMOS EL QUERY PARA EL CONTENIDO DE LA CTE
		SET @SQL_CTE_SELECT = '
			;WITH CTE_INTERACTION AS (
				SELECT ID.[VirtualCC]																						''VCC'',
						ID.[Id] + ''_'' + CONVERT(VARCHAR(10), IMP.[Section]) + ''_'' + CONVERT(VARCHAR(10), IMP.[Part])	''ID'',       
						ID.[Id]																								''InteractionId'',       
						IMP.[Section]																						''Section'',       
						IMP.[Part]																							''Part'',       
						''CALL''																							''Channel'',       
						CASE WHEN ID.Direction = ''E'' THEN CID.CallerId ELSE CID.CalledId END								''Number'',       
						''''																								''Gender'',      
						ID.[HoldTime]																						''SilenceTime'',       
						ID.[AttentionTime]																					''DurationTime'', -- ESTO SE DEBE CORREGIR       
						ID.[AttentionTime]																					''AttentionTime'', -- SE AGREGO CAMPO PARA AMBOS EXISTAN       
						ID.[Campaign]																						''Campaign'',       
						ISNULL(ID.[LastAgent], ID.[FirstAgent])																''Agent'',   
						ID.[ManagementResult]																				''ManagementResult'',
						ID.[Direction]																						''Type'',       
						CONVERT(VARCHAR, ID.[StartDate], 120)																''StartDate'',       
						CONVERT(VARCHAR, ID.[EndDate], 120)																	''EndDate'',       
						IMP.[Format]																						''Format'',       
						CASE WHEN ID.[Direction] = ''E'' THEN CID.[CallerId] ELSE CID.[CalledId] END						''ContactAddress'',       
						CASE WHEN ID.[Direction] = ''E'' THEN CID.[CallerId] ELSE CID.[CalledId] END						''ContactId'',       
						ID.[ContactName]																					''ContactName'',       
						IMP.[RelativePath] + ''/'' + IMP.[FileName]															''RelativeFileName'',       
						RNA = ROW_NUMBER() OVER(PARTITION BY (ID.[Id] + ''_'' + CONVERT(VARCHAR(10), IMP.[Section]) + ''_'' + CONVERT(VARCHAR(10), IMP.Part)) ORDER BY ID.[Id]) -- ROW NUMBER AUDIO            
					FROM [HistoricalData].[dbo].[InteractionDetail] ID (NOLOCK)    
					INNER JOIN [HistoricalData].[dbo].[InteractionMultimediaParts] IMP (NOLOCK)      
						ON IMP.Id = ID.Id
					INNER JOIN [HistoricalData].[dbo].[CallInteractionDetail] CID (NOLOCK)        
						ON ID.Id = CID.Id '
					+ @SQL_CTE_FROM_OPTIONAL
					+ @SQL_CTE_FILTERS_FIXED
					+ @SQL_CTE_FILTERS_OPTIONAL
					+ @SQL_CTE_FILTERS_EXCLUDING + '
			)
			,CTE_WITH_IAD AS (
				SELECT CET_I.*,
						IAD.[ActorName]											 ''agentName'' 
					FROM CTE_INTERACTION CET_I
					LEFT JOIN [HistoricalData].[dbo].[InteractionActorDetail] IAD (NOLOCK)       
						ON IAD.[VirtualCC] = CET_I.[VCC]
							AND IAD.[Id] = CET_I.[InteractionId]        
							AND IAD.[Section] = CET_I.[Section]        
							AND IAD.[Part] = CET_I.[Part]
			)
			,CTE_WITH_CGRM AS (	
				SELECT CTE_C.*,
						ISNULL(CGRM.[Category1], '''')								''Category1'',       
						ISNULL(CGRM.[Category2], '''')								''Category2'',       
						ISNULL(CGRM.[Category3], '''')								''Category3'',       
						ISNULL(CGRM.[Description], '''')							''Description'',       
						ISNULL(CONVERT(VARCHAR(4), CGRM.[Code]), '''')				''DispositionCode'' 
				FROM CTE_WITH_IAD CTE_C 
				LEFT JOIN (       
					SELECT VCC, CampaignID, [Order], [Code],            
							[Description], Category1, Category2, Category3         
						FROM [MMProDat].[dbo].[CampaignGoalResultManagement] (NOLOCK)
						WHERE VCC = ''' + @VCC + '''
				) CGRM         
					ON CGRM.VCC = CTE_C.[VCC]         
						AND CGRM.CampaignId = CTE_C.[Campaign]
						AND CGRM.[Description] = CTE_C.[ManagementResult]'

		-- AGREGAMOS EL SCRIPT PARA RESULTADO DE GESTION
		IF (@ResultCode IS NOT NULL AND @ResultCode <> '') 
		BEGIN
			-- DEBEMOS PASAR LA LISTA DE CAMPAIGNS A UNA TABLA TEMPORAL PARA AGILIZAR LA BUSQUEDA 
			SET @SQL_TMP += '
			SELECT * 
				INTO #FILTER_RESULT_CODES
				FROM (
					SELECT Value FROM [dbo].[split](''' + @ResultCode + ''','','')
				) A '

			-- AGREGAMOS EL JOIN EN LA BUSQUEDA PRINCIPAL
			SET @SQL_CTE_SELECT += '  
				INNER JOIN #FILTER_RESULT_CODES FRC 
					ON (
						FRC.[Value] = CONCAT(CTE_C.[Campaign], ''_'', ISNULL(CONVERT(VARCHAR(4), CGRM.[Code]), ''''))
						OR
						FRC.[Value] = CTE_C.[ManagementResult] 
					) '
		END

		SET @SQL_CTE_SELECT += '
			) -- SELECT * FROM CTE_WITH_CGRM'

		-- ARMAMOS EL QUERY PRINCIPAL
		SET @SQL_CTE = @SQL_TMP + @SQL_CTE_SELECT

		-- SEGUN SI EL SP ES ANIDADO O NO INSERTAMOS EN LA TEMPORAL EXISTENTE O LA CREAMOS
		IF @IS_NESTED = 1 
			SET @SQL_CTE += '
			INSERT INTO #TMP_HD_INTERACTIONS'	
		SET @SQL_CTE += '
			SELECT CTE_C.[ID],
					CTE_C.[InteractionId],
					CTE_C.[Section],
					CTE_C.[Part],
					CTE_C.[Channel],
					CTE_C.[Number],
					CTE_C.[Gender],
					CTE_C.[SilenceTime],
					CTE_C.[DurationTime],
					CTE_C.[AttentionTime],
					CTE_C.[Category1],
					CTE_C.[Category2],
					CTE_C.[Category3],
					CTE_C.[Description],
					CTE_C.[DispositionCode],
					CTE_C.[Campaign],
					CTE_C.[Agent],
					CTE_C.[AgentName],
					CTE_C.[Type],
					CTE_C.[StartDate],
					CTE_C.[EndDate],
					CTE_C.[Format],
					CTE_C.[ContactAddress],
					CTE_C.[ContactId],
					CTE_C.[ContactName],
					CTE_C.[RelativeFileName],
					CTE_C.[RNA] '
		IF @IS_NESTED = 0 
			SET @SQL_CTE += '
				INTO #TMP_HD_INTERACTIONS '
		SET @SQL_CTE += '
				FROM CTE_WITH_CGRM CTE_C
			DROP TABLE IF EXISTS #FILTER_CAMPAIGNS 
			DROP TABLE IF EXISTS #FILTER_AGENTS
			DROP TABLE IF EXISTS #FILTER_RESULT_CODES
			DROP TABLE IF EXISTS #FILTER_INTERACTIONS_IDS '

		-- EJECUTAMOS EL SQL QUE NOS DEJA LA TEMPORAL #TMP_HD_INTERACTIONS CON REGISTROS
		--PRINT @SQL_CTE
		--EXEC (@SQL_CTE)
		--SELECT * FROM #TMP_HD_INTERACTIONS

		-- VARIABLES PARA TRABAJAR CON LA TABLA TEMPORAL AL FINAL DEL SP
		DECLARE @QUERY_SUMMARY VARCHAR(MAX) = ''
		DECLARE @QUERY_DETAIL VARCHAR(MAX) = ''
		DECLARE @QUERY VARCHAR(MAX) = ''
		DECLARE @QUERY_FILTER VARCHAR(MAX) = ''
		DECLARE @QUERY_JOIN VARCHAR(MAX) = ''
	
		-- FILTRO POR INTERACCIONES EVALUADAS O NO
		IF(@Evaluated IS NOT NULL AND @Evaluated <> '')
		BEGIN 
			DECLARE @EvaluatedTable TABLE (Val BIT)
			INSERT INTO @EvaluatedTable SELECT Value FROM [dbo].[split]( @Evaluated ,',')
			-- SOLAMENTE SI ES SI O NO
			IF((SELECT COUNT(Val) FROM @EvaluatedTable) = 1 )
			BEGIN
				IF((SELECT Val FROM @EvaluatedTable WHERE Val = 1) IS NOT NULL) -- Si  es Si
				BEGIN 
					SET @QUERY_JOIN = ' JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) ON (AEP.[IdInteraction] = HDI.[InteractionId] AND AEP.[Completed] = 1) '
				END
				ELSE  --Si es No
				BEGIN
					SET @QUERY_JOIN += ' LEFT JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) ON (AEP.[IdInteraction] = HDI.[InteractionId] AND AEP.[Completed] = 1) '
					SET @QUERY_FILTER = ' AND AEP.[IdInteraction] IS NULL '
				END
			END
		END
		-- FIN FILTRO INTERACCIONES EVALUADAS

		-- SI EL SP NO ESTA ANIDADO, HACEMOS SELECT AL RESULTADO A MOSTRAR
		IF @IS_NESTED = 0
		BEGIN
			-- EN AMBOS CASOS SE REQUIERE EL RESUMEN
			SET @QUERY_SUMMARY = @SQL_CTE + '
				SELECT HDI.[channel]										AS ''interactionType'',
						COUNT(DISTINCT (HDI.[InteractionId]))				AS ''interactions'',
						COUNT(DISTINCT (HDI.[ID]))							AS ''details'',
						SUM(HDI.[AttentionTime])							AS ''attentionTime''
					FROM #TMP_HD_INTERACTIONS HDI '
			SET @QUERY +=  @QUERY_SUMMARY + @QUERY_JOIN
			SET @QUERY += ' WHERE HDI.[RNA] = 1 ' + @QUERY_FILTER + ' GROUP BY HDI.[channel] '

			-- HACEMOS EL SELECT SEGUN EL TIPO DE BUSQUEDA SETTEADO
			--IF @ResultType = 'SUMMARIZED'
			--BEGIN
			-- END
			-- ELSE 
			IF @ResultType = 'DETAILED'
			BEGIN
				SET @QUERY_DETAIL = '
					SELECT HDI.* 
						FROM #TMP_HD_INTERACTIONS HDI ' 
				SET @QUERY += @QUERY_DETAIL + @QUERY_JOIN 
				SET @QUERY += ' WHERE HDI.[RNA] = 1 ' + @QUERY_FILTER + ' '
			END

			-- EJECUTAMOS LA CONSULTA
			PRINT @QUERY
			EXEC (@QUERY)
    
			-- ELIMINAMOS LA TABLA TEMPORARL
			DROP TABLE #TMP_HD_INTERACTIONS
		END

	END
	ELSE
	BEGIN
		SET @Sql = 'SELECT 1 AS ''result'''		
		EXEC (@Sql)
	END

	

END
GO
PRINT N'Modificando Procedimiento [dbo].[GetEvaluations]...';


GO
ALTER PROCEDURE [dbo].[GetEvaluations] (
	@Instance Varchar(50) = NULL,
	@IdAuditor VARCHAR(MAX) = NULL,
	@IdAgent Varchar(MAX) = NULL,
   	@IdCampaign VARCHAR(MAX) = NULL,
	@IdEvaluationPlan VARCHAR(MAX) = NULL,
 	@EvaluationDateFrom VARCHAR(50) = '1980-01-01T00:00:00',
    @EvaluationDateTo VARCHAR(50) = '2050-01-01T23:59:59',
	@EvaluationHourFrom VARCHAR(50) = '00:00:00',
    @EvaluationHourTo VARCHAR(50) = '23:59:59',
	@InteractionMinDuration Int = 0,
    @InteractionMaxDuration Int = 86400,
    @InteractionOrigins Varchar(50) = NULL,
	@InteractionResults Varchar(MAX) = NULL,
	@EvaluationTypes Varchar(MAX) = NULL,
	@InteractionTags Varchar(MAX) = NULL,
	@InteractionFormats Varchar(50) = NULL,
	@InteractionCoached VARCHAR(50) = NULL,
	@InteractionIds     VARCHAR(MAX) = NULL,
	@EvaluationsLimit Int = 0,
	@ContactAddress Varchar(300) = NULL,
	@SentimentIds VARCHAR(MAX) = NULL
)
AS
BEGIN
	SET NOCOUNT ON
	 -- SENTIMIENTOS
	 DECLARE @FILTERS_SENTIMENTIDS VARCHAR(MAX)
	 DECLARE @FILTER_ANALYSIS_TYPE VARCHAR(MAX)
	 SET @FILTERS_SENTIMENTIDS = ''
	 SET @FILTER_ANALYSIS_TYPE = ''
	IF (@SentimentIds IS NOT NULL AND @SentimentIds <> '')
    BEGIN		
		SET @FILTERS_SENTIMENTIDS += '  AND SAR.[SentimentId] IN (SELECT Value FROM [dbo].[split](''' + @SentimentIds + ''','','')) '										
	END
	 
	 IF (SELECT COUNT(*) FROM [dbo].[split](@InteractionOrigins, ',')) = 2 
		SET  @FILTER_ANALYSIS_TYPE =  ' 
				AND SAR.[AnalysisType] ='+''''+'general'+''''
	 IF (@InteractionOrigins = 'IN') 
		SET  @FILTER_ANALYSIS_TYPE =  ' 
				AND SAR.[AnalysisType] ='+''''+'client'+''''
	 IF (@InteractionOrigins = 'OUT') 
		SET  @FILTER_ANALYSIS_TYPE =  ' 
				AND SAR.[AnalysisType] ='+''''+'agent'+''''
	 -- FIN SENTIMIENTOS 
	
	IF (@EvaluationHourFrom = '') SET @EvaluationHourFrom = '00:00:00';
	IF (@EvaluationHourTo = '') SET @EvaluationHourTo = '23:59:59';
	
	-- SI ORIGINS TIENE DOS VALORES, IGNORAMOS EL FILTRO
	IF (SELECT COUNT(*) FROM [dbo].[split](@InteractionOrigins, ',')) = 2 SET @InteractionOrigins = ''
	
	DECLARE @SQL_TMP VARCHAR(MAX) = ''
	DECLARE @SQL_CTE VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_SELECT VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_FROM_FIXED VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_FROM_OPTIONAL VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_FILTERS_FIXED VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_FILTERS_OPTIONAL VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_FILTERS_EXCLUDING VARCHAR(MAX) = ''

	DECLARE @SQL_SELECT_1 VARCHAR(MAX) = ''
	DECLARE @SQL_FROM VARCHAR(MAX) = ''
	DECLARE @SQL_FILTER VARCHAR(MAX) = ''
	DECLARE @SQL_EXTRA VARCHAR(MAX) = ''
	DECLARE @FILTERS_OPTIONAL_PART VARCHAR(MAX) = ''
    DECLARE @FILTERS_EXCLUDING_PART VARCHAR(MAX) = ''
    DECLARE @FILTERS_FIXED_PART     VARCHAR(MAX) = ''

	-- INICIAMOS ARMANDO LOS FILTROS PARA LA TABLA CTE PRINCIPAL
	SET @SQL_CTE_FILTERS_FIXED = '
			WHERE ER.[Instance] = ''' + @Instance + '''
				AND ER.[EvaluationDate] BETWEEN ''' + @EvaluationDateFrom + '''AND ''' + @EvaluationDateTo + '''
				AND EP.[Status] = CASE EP.[Evaluation_Mode] WHEN ''A'' THEN 7 ELSE EP.[Status] END 
				AND AEP.[Completed] = 1 '

	-- AGREGAMOS EL SCRIPT PARA LOS FILREOS DE HORA MAXIMA Y HORA MINIMA LAS CUALES TIENEN UN COMPORTAMIENTO DIFERENTES SEGUN CUAL ES MAYOR
	IF (CAST(@EvaluationHourFrom AS TIME) <= CAST(@EvaluationHourTo AS TIME)) 
		SET @SQL_CTE_FILTERS_OPTIONAL += '
				AND CAST(ER.[EvaluationDate] AS TIME) BETWEEN ''' + @EvaluationHourFrom + ''' AND ''' + @EvaluationHourTo + ''' '
	IF (CAST(@EvaluationHourFrom AS TIME) > CAST(@EvaluationHourTo AS TIME)) 
		SET @SQL_CTE_FILTERS_OPTIONAL += '
				AND CAST(ER.[EvaluationDate] AS TIME) NOT BETWEEN ''' + @EvaluationHourTo + ''' AND ''' + @EvaluationHourFrom + ''' '

	-- AGREGAMOS EL SCRIPT PARA LOS FILREOS DE DURACION MAXIMA Y DURACION MINIMA 
	IF (@InteractionMinDuration IS NOT NULL) 
		SET @SQL_CTE_FILTERS_OPTIONAL += '
				AND AEP.[InteractionDuration] >= ' + (SELECT CONVERT(varchar(10), @InteractionMinDuration)) + ' '
	IF (@InteractionMaxDuration IS NOT NULL) 
		SET @SQL_CTE_FILTERS_OPTIONAL += '
				AND AEP.[InteractionDuration] <= ' + (SELECT CONVERT(varchar(10), @InteractionMaxDuration))+ ' '
	
	-- AGREGAMOS EL SCRIPT PARA EL FILTRO DE ORIGIN
	IF (@InteractionOrigins IS NOT NULL AND @InteractionOrigins != '') 
		SET @SQL_CTE_FILTERS_OPTIONAL += '
				AND AEP.[InteractionOrigin] IN (SELECT Value FROM [dbo].[split](''' + @InteractionOrigins + ''','','')) '

	-- AGREGAMOS EL SCRIPT PARA EL FILTRO DE AUDITOR
	IF (@IdAuditor IS NOT NULL AND @IdAuditor <> '') 
	BEGIN
		-- DEBEMOS PASAR LA LISTA DE AUDITORS A UNA TABLA TEMPORAL PARA AGILIZAR LA BUSQUEDA 
		SELECT * 
			INTO #FILTER_AUDITORS
			FROM (
				SELECT Value FROM [dbo].[split](@IdAuditor, ',')
			) A

		-- AGREGAMOS EL JOIN EN LA BUSQUEDA PRINCIPAL
		SET @SQL_CTE_FROM_OPTIONAL += '  
			INNER JOIN #FILTER_AUDITORS FA 
				ON FA.[Value] = ER.[IdAuditor] ' 
	END

	-- AGREGAMOS EL SCRIPT PARA EL FILTRO DE AGENT
	IF (@IdAgent IS NOT NULL AND @IdAgent != '') 
	BEGIN
		-- DEBEMOS PASAR LA LISTA DE AUDITORS A UNA TABLA TEMPORAL PARA AGILIZAR LA BUSQUEDA 
		SELECT * 
			INTO #FILTER_AGENTS
			FROM (
				SELECT Value FROM [dbo].[split](@IdAgent, ',')
			) A

		-- AGREGAMOS EL JOIN EN LA BUSQUEDA PRINCIPAL
		SET @SQL_CTE_FROM_OPTIONAL += '  
			INNER JOIN #FILTER_AGENTS FAG 
				ON FAG.[Value] = ER.[IdAgent] ' 
	END

	-- AGREGAMOS EL SCRIPT PARA EL FILTRO DE CAMPAIGN
	IF (@IdCampaign IS NOT NULL AND @IdCampaign != '') 
	BEGIN
		-- DEBEMOS PASAR LA LISTA DE AUDITORS A UNA TABLA TEMPORAL PARA AGILIZAR LA BUSQUEDA 
		SELECT * 
			INTO #FILTER_CAMPAIGNS
			FROM (
				SELECT Value FROM [dbo].[split](@IdCampaign, ',')
			) A
		
		-- AGREGAMOS EL JOIN EN LA BUSQUEDA PRINCIPAL
		SET @SQL_CTE_FROM_OPTIONAL += '  
			INNER JOIN #FILTER_CAMPAIGNS FC 
				ON FC.[Value] = ER.[IdCampaign] ' 
	END

	-- AGREGAMOS EL SCRIPT PARA EL FILTRO DE EVALUATION PLAN
	IF (@IdEvaluationPlan IS NOT NULL AND @IdEvaluationPlan != '') 
	BEGIN
		-- DEBEMOS PASAR LA LISTA DE AUDITORS A UNA TABLA TEMPORAL PARA AGILIZAR LA BUSQUEDA 
		SELECT * 
			INTO #FILTER_EVALUATION_PLANS
			FROM (
				SELECT Value FROM [dbo].[split](@IdEvaluationPlan, ',')
			) A 
		
		-- AGREGAMOS EL JOIN EN LA BUSQUEDA PRINCIPAL
		SET @SQL_CTE_FROM_OPTIONAL += '  
			INNER JOIN #FILTER_EVALUATION_PLANS FEP 
				ON FEP.[Value] = ER.[IdEvaluationPlan] ' 
	END

	-- AGREGAMOS EL SCRIPT PARA EL FILTRO DE EVALUATION PLAN
	IF @ContactAddress IS NOT NULL AND @ContactAddress <> ''
	BEGIN
		SET @SQL_CTE_FROM_OPTIONAL += '
				AND AEP.[ContactAddress] LIKE ''%' + @ContactAddress + '%'' '
	END	

	-- AGREGAMOS EL SCRIPT PARA INTERACTION_ID
	IF @InteractionIds IS NOT NULL AND @InteractionIds <> ''
	BEGIN
		SET @SQL_CTE_FROM_OPTIONAL = ''
		SET @SQL_CTE_FILTERS_OPTIONAL = ''
			
		-- DEBEMOS PASAR LA LISTA DE CAMPAIGNS A UNA TABLA TEMPORAL PARA AGILIZAR LA BUSQUEDA 
		SELECT * 
			INTO #FILTER_INTERACTIONS_IDS
			FROM (
				SELECT Value FROM [dbo].[split](@InteractionIds, ',')
			) A

		-- AGREGAMOS EL JOIN EN LA BUSQUEDA PRINCIPAL
		SET @SQL_CTE_FROM_OPTIONAL += '  
			INNER JOIN #FILTER_INTERACTIONS_IDS FID 
				ON FID.[Value] = AEP.[IdInteraction] ' 
		-- SET @SQL_CTE_FILTERS_EXCLUDING = ' AND ID.[Id] IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')) '
	END 

	-- ARMAMOS EL QUERY PARA EL CONTENIDO DE LA CTE
	SET @SQL_CTE_SELECT = '
		;WITH CTE_RESULTS AS (
			SELECT ER.[Instance],
					ER.[IdEvaluationPlan],
					ER.[IdInteraction], 
					IEP.[InteractionSection],
					IEP.[InteractionPart],
					IEP.[InteractionDateEnd],
					ER.[IdAgent],
					IEP.[AgentName],
					IEP.[CreatedDate]
					-- SAR.[SentimentId]
				FROM [dbo].[EvaluationResult] ER (NOLOCK) 
				INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
					ON EP.[Instance] = ER.[Instance]
						AND EP.[Id] =  ER.[IdEvaluationPlan]
				INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) 
					ON (AEP.[Instance] = ER.[Instance] 
						AND AEP.[IdAuditor] = ER.[IdAuditor] 
						AND AEP.[IdInteraction] = ER.[IdInteraction] 
						AND AEP.[InteractionType] = ER.[InteractionType] 
						AND AEP.[IdEvaluationPlan] = ER.[IdEvaluationPlan]) 
				INNER JOIN [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
					ON IEP.[Instance] = ER.[Instance] 
						AND IEP.[IdEvaluationPlan] = EP.[ID]
						AND IEP.[IdInteraction] = ER.[IdInteraction]
						AND IEP.[IdAgent] = ER.[IdAgent] '
					+ @SQL_CTE_FROM_OPTIONAL
					+ @SQL_CTE_FILTERS_FIXED
					+ @SQL_CTE_FILTERS_OPTIONAL
					+ @SQL_CTE_FILTERS_EXCLUDING + '
		)
		,CTE_WITH_SAR AS ( 
			SELECT CTE_R.*,
					SAR.[SentimentId],
					RN = ROW_NUMBER() OVER(PARTITION BY CTE_R.[Instance], CTE_R.[IdEvaluationPlan], CTE_R.[IdInteraction] ORDER BY CTE_R.[CreatedDate] ASC) 
				FROM CTE_RESULTS CTE_R
				LEFT JOIN [dbo].[SentimentAnalysisResult] SAR (NOLOCK)
					ON CTE_R.[Instance] = SAR.[VCC]
						AND CTE_R.[IdInteraction] = SAR.[InteractionId]
						AND CTE_R.[InteractionSection] = SAR.[InteractionSection]
						AND CTE_R.[InteractionPart] = SAR.[InteractionPart]
                        AND ISNULL(CTE_R.[InteractionDateEnd], 0) = ISNULL(SAR.[EndDate], 0)
                        AND SAR.[MaxScore] = 1
						' + @FILTERS_SENTIMENTIDS + '
						' + @FILTER_ANALYSIS_TYPE + '
		)
		,SUMMARIZED_CTE AS (
			SELECT CTE_S.[Instance],
					CTE_S.[IdEvaluationPlan],
					CTE_S.[IdInteraction], 
					CTE_S.[IdAgent],
					CTE_S.[AgentName],
					CTE_S.[SentimentId],
					IIF (
						ERV.[InteractionId] IS NULL,
						CAST(0 AS BIT),
						CAST(1 AS BIT)
					)										''Review'',
					COUNT(ERC.[Id])							''Commitments''
				FROM CTE_WITH_SAR CTE_S
				LEFT JOIN [dbo].[EvaluationReview] ERV (NOLOCK)
					ON ERV.[VCC] = CTE_S.[Instance]
						AND ERV.[EvaluationPlanId] = CTE_S.[IdEvaluationPlan]
						AND ERV.[InteractionId] = CTE_S.[IdInteraction]
				LEFT JOIN [dbo].[EvaluationReviewCommitment] ERC (NOLOCK)
					ON ERC.[VCC] = CTE_S.[Instance] 
						AND ERC.[EvaluationPlanId] = CTE_S.[IdEvaluationPlan]
						AND ERC.[InteractionId] = CTE_S.[IdInteraction]
						-- AND ERC.[SupervisorId] = AEP.[IdAuditor] 
						AND ERC.[AgentId] = CTE_S.[idAgent]
				WHERE RN = 1
				GROUP BY CTE_S.[Instance],
							CTE_S.[IdEvaluationPlan],
							CTE_S.[IdInteraction], 
							ERV.[InteractionId],
							CTE_S.[IdAgent],
							CTE_S.[AgentName],
							CTE_S.[SentimentId]'

	IF @InteractionCoached IS NOT NULL AND @InteractionCoached != ''
	BEGIN
		IF @InteractionCoached = 'true'
			SET @SQL_CTE_SELECT += '
				HAVING COUNT(ERC.[Id]) >= 1 '
		ELSE 
			SET @SQL_CTE_SELECT += '
				HAVING COUNT(ERC.[Id]) = 0 '
	END

	SET @SQL_CTE_SELECT += '
		)'


	SET @SQL_CTE_SELECT += '
		-- SELECT * FROM CTE'

	-- ARMAMOS EL QUERY PRINCIPAL
	SET @SQL_CTE = @SQL_TMP + @SQL_CTE_SELECT

	-- EMPEZAMOS A ARMAN LA QUERY PRINCIPAL
	SET @SQL_SELECT_1 = @SQL_CTE

	SET @SQL_SELECT_1 += '
		SELECT AEP.Completed								''completed'',
				AEP.[StatusDescription]						''statusDescription'',
				A.[ErrorMessage]							''errorMessage'',
    			AEP.[Score]									''qualification'',
    			AEP.[IdAuditor]								''idAuditor'',
    			U.[FirstName] + '' '' + U.[LastName]		''auditorName'',
    			MAX(ER.[EvaluationDate])					''evaluationDate'',
    			AEP.[IdEvaluationPlan]						''idEvaluationPlan'',
				EP.[Description]							''evaluationPlan'',
				EP.[Evaluation_Mode]						''evaluationType'',
    			AEP.[idAgent]								''idAgent'',
    			S_CTE.[AgentName]							''agentName'',							-- NOMBRE DEL AGENTE
				S_CTE.[IdInteraction]						''idInteraction'',
				AEP.[InteractionDate]						''interactionDate'',
    			AEP.[InteractionType]						''interactionType'',
    			AEP.[IdCampaign]							''idCampaign'',
				E.[Type]									''environmentType'',
				S_CTE.[Review]								''review'',
				S_CTE.[Commitments]							''commitments'',
				S_CTE.[SentimentId]							''sentimentResult'' '

	SET @SQL_FROM += '
			FROM SUMMARIZED_CTE S_CTE (NOLOCK) 
			INNER JOIN dbo.[EvaluationResult] ER (NOLOCK) 
				ON ER.[Instance] = S_CTE.[Instance]
					AND ER.[IdEvaluationPlan] = S_CTE.[IdEvaluationPlan]
					AND ER.[IdInteraction] = S_CTE.[IdInteraction]
					AND ER.[IdAgent] = S_CTE.[IdAgent]
			INNER JOIN dbo.[EvaluationPlan] EP (NOLOCK) 
				ON EP.[Instance] = S_CTE.[Instance] 
					AND EP.[ID] = S_CTE.[IdEvaluationPlan]
			INNER JOIN dbo.[AuditorEvaluationPlan] AEP (NOLOCK) 
				ON (AEP.[Instance] = ER.[Instance] 
					AND AEP.[IdAuditor] = ER.[IdAuditor] 
					AND AEP.[IdInteraction] = ER.[IdInteraction] 
					AND AEP.[InteractionType] = ER.[InteractionType] 
					AND AEP.[IdEvaluationPlan] = ER.[IdEvaluationPlan]) 
			LEFT JOIN [dbo].[Audio] A (NOLOCK)
			    ON A.[VCC] = AEP.[Instance]
			        AND A.[ID] = AEP.[IdInteraction]			
			INNER JOIN [dbo].[Environment] E (NOLOCK)
				ON E.[VCC] = ER.[Instance]
					AND E.[Name] = EP.[EnvironmentId]
			INNER JOIN dbo.[User] U (NOLOCK) 
				ON U.[VCC] = ER.[Instance] 
					AND U.[ID] = AEP.[IdAuditor] '

	-- AGREGAMOS EL SCRIPT PARA DISPOSITION CODES
	IF (@InteractionResults IS NOT NULL AND @InteractionResults != '') 
		SET @FILTERS_OPTIONAL_PART += '
				AND (
					(CONCAT(AEP.[IdCampaign], ISNULL(REPLACE(AEP.[ManagementResult], ''/'', ''_''), ''_'')) IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')))
					OR
					(CONCAT(AEP.[IdCampaign], ''_'', ISNULL(AEP.[ManagementResult], ''_'')) IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')))
					OR
					(AEP.[ManagementResult] IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')))
				)'

	-- AGREGAMOS EL SCRIPT PARA EVALUATION TYPE
	IF (@EvaluationTypes IS NOT NULL AND @EvaluationTypes != '') 
	BEGIN
		SET @FILTERS_OPTIONAL_PART += '
				AND EP.[Evaluation_Mode] IN (SELECT Value FROM [dbo].[split](''' + @EvaluationTypes + ''','',''))  '
	END

	-- AGREGAMOS EL SCRIPT PARA SENTIMENT
	IF @SentimentIds IS NOT NULL AND @SentimentIds <> ''
    BEGIN            
	    SET @FILTERS_OPTIONAL_PART=' 
				AND S_CTE.[SentimentId] IN (SELECT Value FROM [dbo].[split](''' + @SentimentIds + ''','','')) '
    END

	-- AGREGAMOS EL SCRIPT PARA TAG
	IF (@InteractionTags IS NOT NULL AND @InteractionTags != '') 
	BEGIN
		SET @SQL_FROM += '
			LEFT JOIN [Tag] T (NOLOCK) 
				ON (T.[VCC] = ER.[Instance] 
					AND T.[Tag] IN (SELECT Value FROM [dbo].[split](''' + @InteractionTags + ''','',''))) '
		SET @FILTERS_OPTIONAL_PART += '
				AND T.[AudioId] LIKE CONCAT(AEP.[IdInteraction], ''%'') 
				AND T.[AudioId] IS NOT NULL '
	END

	SET @SQL_EXTRA += '
			GROUP BY AEP.[Completed],
						AEP.[StatusDescription],
						A.[ErrorMessage],
						AEP.[score],
						AEP.[IdAuditor],
						U.[FirstName] + '' '' + U.[LastName],
						AEP.[IdEvaluationPlan],
						EP.[Description],
						EP.[Evaluation_Mode],
						AEP.[idAgent],
						S_CTE.[AgentName],
						AEP.[InteractionDate],
						AEP.[InteractionType],
						AEP.[IdCampaign], 
						E.[Type],
						S_CTE.[IdInteraction],
						S_CTE.[Review],
						S_CTE.[Commitments],
						S_CTE.[SentimentId]'

	SET @SQL_EXTRA += '
			ORDER BY MAX(ER.[EvaluationDate]) DESC '

	SET @SQL_SELECT_1 += @SQL_FROM  + @FILTERS_FIXED_PART + @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART + @SQL_EXTRA 


	-- ELIMINAMOS LAS TABLAS TEMPORALES
	SET @SQL_SELECT_1 += '
			DROP TABLE IF EXISTS #FILTER_AUDITORS
			DROP TABLE IF EXISTS #FILTER_AGENTS
			DROP TABLE IF EXISTS #FILTER_CAMPAIGNS 
			DROP TABLE IF EXISTS #FILTER_EVALUATION_PLANS
			DROP TABLE IF EXISTS #FILTER_INTERACTIONS_IDS '

	-- EJECUTAMOS EL QUERY ARMADO
	-- PRINT @SQL_SELECT_1
	EXEC (@SQL_SELECT_1)
	
END
GO
PRINT N'Modificando Procedimiento [dbo].[ReportBySummaryAgent]...';


GO


ALTER PROCEDURE [dbo].[ReportBySummaryAgent] (
	@VCC varchar(50) = NULL, 
	@HistoricCampaign varchar(MAX) = NULL, 
	@Plan varchar(MAX) = NULL,
	@Format varchar(MAX) , 
	@StartDate DateTime = NULL , 
	@EndDate DateTime = NULL , 
	@IdAuditor varchar(MAX) = NULL ,
	@IdAgente varchar(MAX) = NULL
) AS
  DECLARE @cols varchar(max)
  DECLARE @query varchar(max)
  --ReportBySummaryAgent 'allegro','entrantes',NULL,'nov01-0356',NULL,NULL,NULL,NULL
  --SET @Format = 'nov01-0356'
  SET NOCOUNT ON
  
  SELECT
    * INTO #TempEvaluationResult
  FROM (
  SELECT
    EP.Description AS 'DescriptionPlan',
    EF.Description AS 'DescriptionFormat',
    GP.Description + '-' + SGP.Description + '-' + A.Title AS 'Ability',
    ER.AgentDescription,
    ER.CampaignDescription,
    ER.IdInteraction,
    ER.Qualification,
    Format(ER.EvaluationDate, 'dd/MM/yyyy hh:mm:ss') AS 'EvaluationDate',
    ER.IdAuditor,
    EP.Evaluation_Mode
  FROM EvaluationResult (NOLOCK) ER
  LEFT JOIN HistoricEvaluationFormat (NOLOCK) EF
    ON ER.IdEvaluationFormat = EF.ID AND ER.IdEvaluationPlan = EF.EvaluationPlanId
  LEFT JOIN HistoricAbility (NOLOCK) A
    ON A.ID = ER.IdAbility AND ER.IdEvaluationPlan = A.EvaluationPlanId
  LEFT JOIN EvaluationPlan (NOLOCK) EP
    ON EP.ID = ER.IdEvaluationPlan
  LEFT JOIN [HistoricGroup] (NOLOCK) GP
    ON GP.ID = ER.IdGroup AND EP.ID = GP.EvaluationPlanId
  LEFT JOIN HistoricSubGroup SGP (NOLOCK)
    ON SGP.ID = ER.IdSubGroup AND EP.ID = SGP.EvaluationPlanId
	WHERE ER.Instance LIKE CASE
			WHEN @VCC IS NOT NULL THEN @VCC
			ELSE ER.Instance
			END
		AND ER.[IdEvaluationPlan] IN(SELECT [Value] FROM [dbo].[Split](IIF(@Plan IS NULL,EP.Description,@Plan),','))
		AND ER.[IdEvaluationFormat] IN (SELECT [Value] FROM [dbo].[Split](IIF(@Format IS NULL,EF.Description,@Format),','))
		AND ER.CampaignDescription IN(SELECT [Value] FROM [dbo].[Split](IIF(@HistoricCampaign IS NULL,ER.CampaignDescription,@HistoricCampaign),','))
		AND ER.AgentDescription IN(SELECT [Value] FROM [dbo].[Split](IIF(@IdAgente IS NULL,ER.AgentDescription,@IdAgente),','))
		AND ER.IdAuditor IN(SELECT [Value] FROM [dbo].[Split](IIF(@IdAuditor IS NULL,ER.IdAuditor,@IdAuditor),','))
		AND ER.EvaluationDate >=
                          CASE
                            WHEN @StartDate IS NOT NULL THEN @StartDate
                            ELSE '19800101'
                          END
		AND ER.EvaluationDate <
                         CASE
                           WHEN @EndDate IS NOT NULL THEN @EndDate + ' 23:59'
                           ELSE '20500101'
                         END
	) a

	
	SET @cols = STUFF(
		(
			SELECT (',' + QUOTENAME(TMP_ER.[Ability]))
				FROM #TempEvaluationResult TMP_ER
				GROUP BY TMP_ER.[Ability] 
				ORDER BY TMP_ER.[Ability] 
			FOR xml PATH (''), TYPE
		).value('.', 'varchar(Max)')
		, 1, 1, '')
  
  IF @cols IS NOT NULL
  BEGIN
    ------
    DECLARE @type varchar(max) = (SELECT TOP 1
      Evaluation_Mode
    FROM #TempEvaluationResult)
	
	-------
    DECLARE @Total varchar(max) = STUFF(
		(
			SELECT '+ ISNULL(' + QUOTENAME(TMP_ER.[Ability]) + ',0)'
				FROM #TempEvaluationResult TMP_ER
				GROUP BY TMP_ER.[Ability] 
				ORDER BY TMP_ER.[Ability] 
			FOR xml PATH (''), TYPE
		).value('.', 'varchar(Max)')
		, 1, 1, '')    
	
	-- ROUND(AVG(CAST(ER.Qualification AS float)), 2) AS 'Qualification',
    DECLARE @colavg varchar(max) = STUFF(
		(
			SELECT ', ROUND(AVG(CAST(q.' + QUOTENAME(TMP_ER.[Ability]) + ' AS float)), 2) As [' + TMP_ER.[Ability] + ' Promedio]'
				FROM #TempEvaluationResult TMP_ER
				GROUP BY TMP_ER.[Ability] 
				ORDER BY TMP_ER.[Ability] 
			FOR xml PATH (''), TYPE
		).value('.', 'varchar(Max)')
		, 1, 1, '')
	
	--SELECT @colavg
    IF @type = 'M'
    BEGIN
      SET @query = ' 
				Select 
				q.DescriptionPlan As   [EVALUATION_PLAN] ,
				q.DescriptionFormat As [EVALUATION_FORMAT] ,
				q.AgentDescription As  [AGENT] ,
				q.CampaignDescription As [CAMPAIGN] ,
				count(q.IdInteraction) As [AUDITS],
				sum(q.DurationTime) As [DURATION_TIME],
				ROUND(AVG(CAST(q.Note AS float)), 2) As [AVERAGE_SCORE],
				' + @colavg + ' From
				(Select p.DescriptionPlan,p.DescriptionFormat,p.AgentDescription,
  				p.CampaignDescription,p.IdInteraction,p.EvaluationDate,p.IdAuditor,InteractionDuration as DurationTime, 
				null As Number,InteractionDateStart As StartDate,null As Category1,(' + @Total + ') As Note, ' + @cols + ' from 
				( select DescriptionPlan,
						  DescriptionFormat,
						  Ability,
						  AgentDescription,
						  CampaignDescription,
						  IdInteraction,
						  EvaluationDate,
						  Qualification,
						  IdAuditor			
					from #TempEvaluationResult
			   ) x
				pivot 
				( 
					 max(Qualification)
					for Ability in (' + @cols + ')
				) p 
				Left Join (
				Select Distinct IdInteraction,InteractionDuration,InteractionDateStart From InteractionEvaluationPlan (Nolock)
				) as A On
				A.IdInteraction=p.IdInteraction)q
				Group By 
				q.DescriptionPlan,q.DescriptionFormat,q.AgentDescription,q.CampaignDescription
				'
    END
    ELSE
    BEGIN
      SET @query = '
	
			    Select 
				q.DescriptionPlan As   [EVALUATION_PLAN] ,
				q.DescriptionFormat As [EVALUATION_FORMAT] ,
				q.AgentDescription As  [AGENT] ,
				q.CampaignDescription As [CAMPAIGN] ,
			    count(q.IdInteraction) As [AUDITS],
				sum(q.DurationTime) As [DURATION_TIME],
				ROUND(AVG(CAST(q.Note AS float)), 2) As [AVERAGE_SCORE],
				' + @colavg + '
				From 
				(Select p.DescriptionPlan,p.DescriptionFormat,p.AgentDescription,
  				p.CampaignDescription,p.IdInteraction,p.EvaluationDate,p.IdAuditor,
				A.DurationTime,A.Number,A.StartDate,A.Category1,(' + @Total + ') As Note, ' + @cols + ' from 
				( select DescriptionPlan,
						  DescriptionFormat,
						  Ability,
						  AgentDescription,
						  CampaignDescription,
						  IdInteraction,
						  EvaluationDate,
						  Qualification,
						  IdAuditor			
					from #TempEvaluationResult
			   ) x
				pivot 
				( 
					 max(Qualification)
					for Ability in (' + @cols + ')
				) p 
				Left Join Audio as A On
				A.ID=p.IdInteraction)q
				Group By 
				q.DescriptionPlan,q.DescriptionFormat,q.AgentDescription,q.CampaignDescription'
    END
    --Print(@query)
    EXECUTE (@query)
    --Select * From @query
	

    DROP TABLE #TempEvaluationResult
  END
  ELSE
  BEGIN
    DROP TABLE #TempEvaluationResult
    SELECT
						''				As [EVALUATION_PLAN],
						''				As [EVALUATION_FORMAT],
						''				As [AGENT],
  						''			    As [CAMPAIGN] 
  END
  
  SET NOCOUNT OFF
GO
PRINT N'Modificando Procedimiento [dbo].[SaveEvaluationBaseResult]...';


GO
ALTER PROCEDURE [dbo].[SaveEvaluationBaseResult] (
	@VCC VARCHAR(50) = NULL,
	@EVALUATION_PLAN_ID VARCHAR(100) = NULL,
	@ABILITY_TYPE VARCHAR(50) = NULL
) AS

BEGIN
	-- ALERTA: NO ESTA PROBBADO PARA PLAN MANUAL

	-- ESTE SP INSERTA LOS RESULT BASE DE UN PLAN AUTOMATICO/MIXTO
	SET NOCOUNT ON

	-- SETTEAMOS EL TYPE ABILITY COMO AUTOMATIC PO DEFECTO
	IF @ABILITY_TYPE IS NULL SET @ABILITY_TYPE = 'AUTOMATIC'

	-- EMULAMOS UNA NUEVA TABLA VARIABLE PARA OBTENER LOS REGISTROS UNICOS QUE INSERTAREMOS EN LA TABLA EVALUATION_RESULT
	--  ORDENANDO POR SECTION Y PART

	DROP TABLE IF EXISTS #TMP_TRANSCRIBED_CALL_INTERACTIONS
	DROP TABLE IF EXISTS #TMP_RESULTS_FOR_EVALUATION 
	DROP TABLE IF EXISTS #TMP_EVALUATIONS_RESULTS

	-- CREAMOS UNA TABLA TEMPORAL PARA ALMACENAR LAS INTERACCIONES CALL YA TRANSRITAS
	SELECT A.[ID]
		INTO #TMP_TRANSCRIBED_CALL_INTERACTIONS
		FROM [dbo].[Audio] A (NOLOCK)
		INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK)
			ON PA.[VCC] = A.[VCC]
				AND PA.[AudioId] = A.[ID] 
		INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
			ON EP.[Instance] = A.[VCC]
				AND EP.[ProcessId] = PA.[ProcessId]
		WHERE A.[VCC] = @VCC 
			AND A.[IsTranscribed] = 1
			AND EP.[ID] = @EVALUATION_PLAN_ID

	-- SELECT * FROM #TMP_TRANSCRIBED_CALL_INTERACTIONS
	
	-- CREAMOS UNA TABLA TEMPORAL PARA ALMACENAR LAS INTERACCIONES TEXT YA TRANSRITAS
	SELECT AI.[ID]
		INTO #TMP_TRANSCRIBED_TEXT_INTERACTIONS
		FROM [dbo].[AsyncInteraction] AI (NOLOCK)
		INNER JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
			ON PAI.[VCC] = AI.[VCC]
				AND PAI.[InteractionId] = AI.[ID]
				AND PAI.[FormattedEndDate] = AI.[Folder]
		INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
			ON EP.[Instance] = AI.[VCC]
				AND EP.[ProcessId] = PAI.[ProcessId]
		WHERE AI.[VCC] = @VCC 
			AND AI.[IsTranscribed] = 1
			AND EP.[ID] = @EVALUATION_PLAN_ID

	-- CREAMOS UNA TABLA TEMPORAL PARA ALMACENAR LOS EVALUATION_RESULT YA REGISTRADOS
	SELECT ER.*
		INTO #TMP_EVALUATIONS_RESULTS
		FROM [dbo].[EvaluationResult] ER (NOLOCK) 
		WHERE ER.[Instance] = @VCC 
			AND ER.[IdEvaluationPlan] = @EVALUATION_PLAN_ID

	-- SELECT * FROM #TMP_TRANSCRIBED_TEXT_INTERACTIONS
	
	-- GENERAMOS REGISTROS PARA TODAS LAS INTERACCIONES
	;WITH VALID_INTERACTIONS_CTE AS (
		SELECT [ID] FROM #TMP_TRANSCRIBED_CALL_INTERACTIONS
		UNION ALL
		SELECT [ID] FROM #TMP_TRANSCRIBED_TEXT_INTERACTIONS
	)
	, INTERACTIONS_ALL_CTE AS (
		SELECT IEP.[Instance],
				IEP.[IdEvaluationPlan],
				IEP.[IdCampaign],
				IEP.[IdInteraction],
				IEP.[IdAgent],
				IEP.[InteractionDateStart],
				IEP.[InteractionDateEnd],
				IEP.[InteractionType],
				IEP.[ContactId],
				RN = ROW_NUMBER() OVER(PARTITION BY IEP.[Instance],
													IEP.[IdEvaluationPlan],				
													IEP.[IdCampaign],
													IEP.[IdInteraction],
													IEP.[IdAgent],
													IEP.[InteractionDateStart],
													IEP.[InteractionDateEnd],
													IEP.[InteractionType],
													IEP.[ContactId]
										ORDER BY IEP.[InteractionSection] ASC, IEP.[InteractionPart] ASC)
			FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
			INNER JOIN VALID_INTERACTIONS_CTE IA_CTE 
				ON IA_CTE.[ID] = IEP.[IdInteraction]
			WHERE IEP.[Instance] = @VCC
				AND IEP.[IdEvaluationPlan] = @EVALUATION_PLAN_ID
	)  -- SELECT * FROM INTERACTIONS_ALL_CTE RETURN
	, INTERACTIONS_SUMMARY_CTE AS (
		SELECT I_A_CTE.*
			FROM INTERACTIONS_ALL_CTE I_A_CTE
			WHERE I_A_CTE.RN = 1
	) -- SELECT * FROM INTERACTIONS_SUMMARY_CTE RETURN
	, INTERACTIONS_FIRST_FILTER_CTE AS (
		SELECT * 
			FROM INTERACTIONS_SUMMARY_CTE IS_CTE
			WHERE (
					IS_CTE.[InteractionType] = 'CALL' 
					AND 
					IS_CTE.[IdInteraction] IN (
						SELECT [ID] FROM #TMP_TRANSCRIBED_CALL_INTERACTIONS
					)
				)
				OR
				IS_CTE.[InteractionType] <> 'CALL' 
	)  -- SELECT * FROM INTERACTIONS_FIRST_FILTER_CTE RETURN /*
	-- TODO: EL SECOND_FILTER ES SOBRE LAS INTERACCIONES TEXT TRANSCRITAS
	, MAIN_CTE AS (
		SELECT EP.[Instance]										'vcc',
				EP.[ID]												'IdEvaluationPlan',
				EP.[IdEvaluationFormat]								'IdEvaluationFormat',
				HEF.[MinQualificationAcceptable]					'MinQualificationAcceptable',
				IFF_CTE.[IdInteraction]								'IdInteraction',
				IFF_CTE.[IdCampaign]								'IdCampaign',
				IFF_CTE.[IdAgent]									'IdAgent',
				EP.[ProcessId]										'ProcessId',
				HAEF.[IdGroup]										'IdGroup',
				HAEF.[IdSubGroup]									'IdSubGroup',
				HAEF.[IdAbility]									'IdAbility',
				HAEF.[Score]										'MaxAbilityScore',
				HS.[Value]											'AbilityInnerScore',
				HS.[Description]									'ScoreDescription',
				IFF_CTE.[IdCampaign]								'CampaignDescription',
				IFF_CTE.[IdAgent]									'AgentDescription',
				IFF_CTE.[InteractionDateStart]						'InteractionDateini',
				IFF_CTE.[InteractionDateEnd]						'InteractionDatefin',
				IFF_CTE.[ContactId]									'InteractionAddress',
				HAEF.[Order]										'AbilityOrder',
				IFF_CTE.[InteractionType]							'InteractionType',
				HAEF.[ID]											'IdAbilityEvaluationFormat',
				HAEF.[Conditional]									'Conditional'
			FROM [dbo].[EvaluationPlan] EP (NOLOCK)
			INNER JOIN [dbo].[HistoricEvaluationFormat] HEF (NOLOCK)
				ON HEF.[VCC] = EP.[Instance]
					AND HEF.[EvaluationPlanId] = EP.[ID]
			INNER JOIN [dbo].[HistoricAbilityEvaluationFormat] HAEF (NOLOCK)
				ON HAEF.[VCC] = EP.[Instance]
					AND HAEF.[EvaluationPlanId] = EP.[ID]
			INNER JOIN [dbo].[HistoricAbility] HA (NOLOCK)
				ON HA.[VCC] = EP.[Instance]
					AND HA.[EvaluationPlanId] = EP.[ID]
					AND HA.[ID] = HAEF.[IdAbility]
			INNER JOIN [dbo].[HistoricScore] HS (NOLOCK)
				ON HS.[VCC] = EP.[Instance]
					AND HS.[EvaluationPlanId] = EP.[ID]
					AND HS.[IdAbility] = HA.[ID]
					AND HS.[Value] = IIF(HA.[IsNegative] = 1, 100, 0)
			INNER JOIN INTERACTIONS_FIRST_FILTER_CTE IFF_CTE 
				ON IFF_CTE.[Instance] = EP.[Instance]
					AND IFF_CTE.[IdEvaluationPlan] = EP.[ID]
			LEFT JOIN #TMP_EVALUATIONS_RESULTS TMP_ER 
				ON TMP_ER.[Instance] = EP.[Instance]
					AND TMP_ER.[IdEvaluationPlan] = EP.[ID]
					AND TMP_ER.[IdInteraction] = IFF_CTE.[IdInteraction]
					AND TMP_ER.[IdAbility] = HA.[ID]
					AND TMP_ER.[IdAgent] = IFF_CTE.[IdAgent]
					AND TMP_ER.[IdAbilityEvaluationFormat] = HAEF.[ID]
			WHERE TMP_ER.[Instance] IS NULL
				AND EP.[Instance] = @VCC
				AND IFF_CTE.[IdInteraction] IS NOT NULL
			    AND EP.[ID] = @EVALUATION_PLAN_ID
				AND (
					(
						@ABILITY_TYPE = 'AUTOMATIC' 
						AND 
						HA.[Type] = 'MANUAL_AUTOMATIC'
					)
					OR
					(
						@ABILITY_TYPE = 'MANUAL' 
						AND 
						HA.[Type] = 'MANUAL'
					)
				)
	)  -- SELECT * FROM MAIN_CTE RETURN
	
		
	-- INSERTAMOS TODOS LOS REGISTROS EN UNA TABLA TEMPORAL
	SELECT * -- 0 'DEBUG'
		INTO #TMP_RESULTS_FOR_EVALUATION
		FROM MAIN_CTE
	
	-- ELIMINAMOS LOS REGISTROS PARA INTERACCIONES TEXT NO TRANSCRITAS
	/*
	DELETE FROM TMP_RESULTS_FOR_EVALUATION
		WHERE [InteractionType] <> 'CALL' 
			AND [IdInteraction] NOT IN (
				SELECT [ID] FROM #TMP_NOT_TRANSCRIBED_TEXT_INTERACTIONS
			)
			*/

	-- TENEMOS LOS REGISTROS PARA INSERTAR EN EVALUATIONRESULT
	-- SELECT * FROM #TMP_RESULTS_FOR_EVALUATION RETURN

	-- INSERTAMOS SOLO LAS PRIMERAS OCURRENCIAS PARA CADA INTERACCION
	INSERT INTO [dbo].[EvaluationResult] (
		[Instance], [IdCampaign], [IdInteraction],
		[IdAgent], [IdEvaluationFormat], [MinQualificationAcceptable],
		[IdGroup], [IdSubGroup], [IdAbility],
		[Qualification], [OwnScore], [AbilityInnerScore],
		[IdEvaluator], [EvaluationDate], [MaxAbilityScore],
		[IdEvaluationPlan], [CreatedDate], [CreatedByUserId],
		[LastModifiedDate], [LastModifiedByUserId], [TimeStamp],
		[Comment], [NotApplies], [ScoreDescription],
		[CampaignDescription], [AgentDescription], [InteractionDateini],
		[InteractionDatefin], [InteractionAddress], [AbilityOrder],
		[InteractionType], [IdAbilityEvaluationFormat],  [IdAuditor],
		[Conditional]
	)
		SELECT TMP_RFE.[vcc], TMP_RFE.[IdCampaign], TMP_RFE.[IdInteraction],
				TMP_RFE.[IdAgent], TMP_RFE.[IdEvaluationFormat], TMP_RFE.[MinQualificationAcceptable],
				TMP_RFE.[IdGroup], TMP_RFE.[IdSubGroup], TMP_RFE.[IdAbility],
				(TMP_RFE.[MaxAbilityScore] * TMP_RFE.[AbilityInnerScore] / 100), (TMP_RFE.[MaxAbilityScore] * TMP_RFE.[AbilityInnerScore] / 100), TMP_RFE.[AbilityInnerScore],
				'SPEECH', GETUTCDATE(), TMP_RFE.[MaxAbilityScore],
				TMP_RFE.[IdEvaluationPlan], GETUTCDATE(), 'SPEECH',
				--'100', TMP_RFE.[IdEvaluationPlan], GETUTCDATE(),
				GETUTCDATE(), 'SPEECH', GETUTCDATE(),
				NULL, '0', TMP_RFE.[ScoreDescription],
				TMP_RFE.[CampaignDescription], TMP_RFE.[AgentDescription], TMP_RFE.[InteractionDateini],
				TMP_RFE.[InteractionDatefin], TMP_RFE.[InteractionAddress], TMP_RFE.[AbilityOrder],
				TMP_RFE.[InteractionType], TMP_RFE.[IdAbilityEvaluationFormat], 'SPEECH',
				TMP_RFE.[Conditional]
			FROM #TMP_RESULTS_FOR_EVALUATION TMP_RFE

	-- ELIMINAMOS LAS TABLAS TEMPORALES
	DROP TABLE #TMP_TRANSCRIBED_CALL_INTERACTIONS
	DROP TABLE #TMP_RESULTS_FOR_EVALUATION
	DROP TABLE #TMP_EVALUATIONS_RESULTS

	SET NOCOUNT OFF

END
GO
PRINT N'Modificando Procedimiento [dbo].[BulkAbilityCognitive]...';


GO
ALTER PROCEDURE [dbo].[BulkAbilityCognitive]
AS
BEGIN
	SET NOCOUNT ON

	/*-- INSERTAMOS LA DATA DE LA TEMPORAL PARA DEPURAR EL SP MANUALMENTE
	IF OBJECT_ID(N'[dbo].[TMP_BULK_INTENT]', N'U') IS NULL
	BEGIN
		SELECT *
			INTO [dbo].[TMP_BULK_INTENT]
			FROM [dbo].[#AbilityCognitiveTemp]

		/*
		SELECT * FROM [dbo].[TMP_BULK_INTENT] (NOLOCK)
		SELECT * 
			INTO [#AbilityCognitiveTemp]
			FROM [dbo].[TMP_BULK_INTENT] (NOLOCK)
		SELECT * FROM [#AbilityCognitiveTemp]
		*/
	END
	ELSE
	BEGIN
		INSERT INTO [dbo].[TMP_BULK_INTENT]
			SELECT * 
				FROM [dbo].[#AbilityCognitiveTemp]
	END
	*/
	
	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS PLANES Y SU CORRESPONDIENTE VCC
	DECLARE MY_CURSOR CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
		FOR 
		-- CONSULTAMOS LOS ID DE PLANES EN LA TABLA TEMPORAL
		SELECT DISTINCT ACTMP.[VCC],
							ACTMP.[EvaluationPlanId] 'EVALUATION_PLAN_ID'
						FROM [#AbilityCognitiveTemp] ACTMP (NOLOCK)
						WHERE ACTMP.[VCC] IS NOT NULL 
							AND ACTMP.[EvaluationPlanId] IS NOT NULL

	-- DECLARARAMOS VARIABLES PARA INDICAR EL PLAN Y VCC
	DECLARE @CURRENT_VCC VARCHAR(50) = ''
	DECLARE @CURRENT_EVALUATION_PLAN_ID VARCHAR(100) = ''

	-- ABRIMOS Y RECORREMOS EL ARRAY DE PLANES
	OPEN MY_CURSOR
	FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		-- EJECUTAMOS EL SP QUE INSERTA LOS RESULT BASE DE LOS PLANES QUE AUN NO LOS TIENEN
		EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'AUTOMATIC'
			
		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	END
	CLOSE MY_CURSOR
	DEALLOCATE MY_CURSOR
	
	-- ACTUALIZAMOS LOS EVALUATION RESULT DE LAS HABILIDADES EN LA TABLA TEMPORAL DEL BULK
	UPDATE ER
		SET ER.[Qualification] = (AEF.[Score] * S.[Value]) / 100,
			ER.[OwnScore] = (AEF.[Score] * S.[Value]) / 100,
			ER.[ScoreDescription] = S.[Description],
			ER.[AbilityInnerScore] = S.[Value]
		FROM [#AbilityCognitiveTemp] ACTMP 
		INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
			ON EP.[ID] = ACTMP.[EvaluationPlanId]
		INNER JOIN [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
			ON AEF.[Instance] = EP.[Instance]
				AND AEF.[IdEvaluationFormat] = EP.[IdEvaluationFormat]
				AND AEF.[IdAbility] = ACTMP.[AbilityId]
		INNER JOIN EvaluationResult ER (NOLOCK)
			ON ER.[Instance] = EP.[Instance] 
				AND ER.[IdEvaluationFormat] = EP.[IdEvaluationFormat]
				AND ER.[IdInteraction] = ACTMP.[ID]
		INNER JOIN [dbo].[Ability] A (NOLOCK) 
	       ON A.[Instance] = ER.[Instance] 
	            AND A.[ID] = ER.[IdAbility]
		INNER JOIN [dbo].[Score] S (NOLOCK)
			ON S.[IdAbility] = ACTMP.[AbilityId]
				AND S.[Value] = IIF(A.[IsNegative] = 1, 0, 100)
		WHERE AEF.[IdAbility] = ER.[IdAbility]
			AND ER.[IdAuditor] = 'SPEECH'

	/* Script para actualizar la tabla AuditorEvaluationPlan a Completed y Suma de Scores de la evaluacion */
	UPDATE AEP
		SET --AEP.[Completed] = '1',
			AEP.[Completed] = CASE WHEN AEPR.[Evaluation_Mode] = 'X' AND AEPR.[MinAutomaticQualification] <= AEPR.[SCORE] THEN '0' ELSE '1' END,
			AEP.[StatusDescription] = CASE WHEN AEPR.[Evaluation_Mode] = 'X' AND AEPR.[MinAutomaticQualification] <= AEPR.[SCORE] THEN 'NEW' ELSE 'COMPLETED' END,
			AEP.[Score] = AEPR.[SCORE],
			AEP.[AutomaticScore] = AEPR.[SCORE],
			-- AEP.[ManualScore] = AEPR.[SCORE], -- UNA EVALUACION AUTOMATICA DEBE TENER 0 DE MANUALSCORE
			AEP.[ManualScore] = 0,
			AEP.[LastModifiedDate] = GETUTCDATE(),
			AEP.[TimeStamp] = GETUTCDATE()
		FROM AuditorEvaluationPlan AEP (NOLOCK)
		LEFT JOIN (
			SELECT AEP.[Instance],
				AEP.[IdEvaluationPlan],
				AEP.[IdInteraction],
				EP.[Evaluation_Mode],
				EF.[MinAutomaticQualification],
				SUM(ER.[Qualification]) AS SCORE
			FROM AuditorEvaluationPlan AEP (NOLOCK)
			LEFT JOIN EvaluationPlan EP (NOLOCK)
				ON EP.[Instance] = AEP.[Instance]
					AND EP.[ID] = AEP.[IdEvaluationPlan] 
			LEFT JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
				ON EF.[Instance] = AEP.[Instance]
					AND EF.[ID] = EP.[IdEvaluationFormat]
			LEFT JOIN EvaluationResult ER (NOLOCK)
				ON ER.[Instance] = AEP.[Instance]
					AND ER.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
					AND ER.[IdInteraction] = AEP.[IdInteraction]
			LEFT JOIN AbilityEvaluationFormat AEF (NOLOCK) 
				ON AEF.[Instance] = EP.[Instance]
					AND AEF.[IdEvaluationFormat] = EP.[IdEvaluationFormat]
					AND AEF.[IdAbility] = ER.[IdAbility]
			LEFT JOIN (SELECT DISTINCT ACTMP.[VCC],
									ACTMP.[EvaluationPlanId]
								FROM [#AbilityCognitiveTemp] ACTMP (NOLOCK)
								WHERE ACTMP.[VCC] IS NOT NULL 
									AND ACTMP.[EvaluationPlanId] IS NOT NULL) TMP 
				ON TMP.[VCC] = AEP.[Instance]
					AND TMP.[EvaluationPlanId] = AEP.[IdEvaluationPlan]
			WHERE TMP.[EvaluationPlanId] = AEP.[IdEvaluationPlan]
				AND AEP.[IdAuditor] = 'SPEECH'
			GROUP BY AEP.[Instance], AEP.[IdEvaluationPlan], AEP.[IdInteraction], EP.[Evaluation_Mode], EF.[MinAutomaticQualification]
		) AEPR 
		ON AEPR.[Instance] = AEP.[Instance]
			AND AEPR.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
			AND AEPR.[IdInteraction] = AEP.[IdInteraction]
		WHERE AEPR.[Instance] = AEP.[Instance]
			AND AEPR.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
			AND AEPR.[IdInteraction] = AEP.[IdInteraction]
	
	;
	/****************************************************************************************/
	/*INICIO SECCION PARA ACTUALIZAR LA CALIFICACION TOTAL DE LA EVALUACION C/S PENALIZACION*/
	/****************************************************************************************/
	
	-- EMULAMOS UNA NUEVA TABLA VARIABLE PARA DETERMINAR LAS INTERACCIONES QUE TIENEN HABILIDAD(ES) PENALIZADA(S) POR NOTA CERO
	--  ORDENANDO POR PRIORIDAD (INTERACCION 1, GRUPO 2 Y SUBGRUPO 3)
	WITH CTEFP AS (
		SELECT DISTINCT 
				ER.[Instance],
				ER.[IdInteraction],
				ER.[IdEvaluationPlan],
				ER.[IdEvaluationFormat],
				ER.[IdAbility],
				CASE WHEN ER.[AbilityInnerScore] = 0 AND AEF.[Penalizes] <> 'NO' THEN 1 ELSE 0 END 'Penalized',
				AEF.[Penalizes],
				CASE AEF.[Penalizes]
					WHEN 'INT' THEN ER.[IdInteraction] 
					WHEN 'GRP' THEN ER.[IdGroup] 
					WHEN 'SGR' THEN ER.[IdSubGroup] 
				END 'PenalizedOn',
				RN = ROW_NUMBER() OVER(PARTITION BY ER.[IdInteraction], CASE WHEN ER.[AbilityInnerScore] = 0 THEN 1 ELSE 0 END 
					ORDER BY CASE AEF.[Penalizes]
					WHEN 'INT' THEN 1 
					WHEN 'GRP' THEN 2 
					WHEN 'SGR' THEN 3 
				END)
			FROM [EvaluationResult] ER (NOLOCK) 
			LEFT JOIN [AbilityEvaluationFormat] AEF (NOLOCK) 
				ON AEF.[Instance] = ER.[Instance] 
					AND AEF.[IdEvaluationFormat] = ER.[IdEvaluationFormat]
					AND AEF.[IdAbility] = ER.[IdAbility]
			WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM [#AbilityCognitiveTemp]) 
				AND ER.[Qualification] = 0 
				AND AEF.[Penalizes] <> 'NO'
			-- WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EPA.[EvaluationPlanId] FROM [DummyEvaluationPlanAbility] EPA (NOLOCK) WHERE EPA.[EvaluationPlanId] IS NOT NULL)
	),

	-- ALMACENAMOS EL RESULTADO AGRUPADO DE LAS EVALUACIONES EN UNA TABLA VARIABLE PARA HACER UN CRUCE DIRECTO CON
	--  LA TABLA AuditorEvaluationPlan
	CTEFS AS (
		SELECT ER.[Instance],
				ER.[IdEvaluationPlan],
				ER.[IdInteraction],
				ER.[IdAuditor],
				SUM(ER.[Qualification])															'TOTAL_SCORE',
				SUM(IIF(HA.[Type] = 'MANUAL_AUTOMATIC', ER.[Qualification], 0))					'TOTAL_AUTOMATIC_SCORE',
				SUM(IIF(HA.[Type] = 'MANUAL', ER.[Qualification], 0))							'TOTAL_MANUAL_SCORE',
				--SUM(ER.[Qualification] * CASE WHEN FP2.[Penalized] IS NULL THEN 1 ELSE 0 END) 'PENALIZED_SCORE',
				SUM(ER.[Qualification] * (
					CASE WHEN (
						CASE FP2.[Penalizes]
							WHEN 'INT' THEN ER.[IdInteraction] 
							WHEN 'GRP' THEN ER.[IdGroup] 
							WHEN 'SGR' THEN ER.[IdSubGroup] 
						END = FP2.[PenalizedOn]
						AND FP2.[Penalized] = 1) THEN 0 ELSE 1 END
				))																				'PENALIZED_SCORE',
				SUM(IIF(HA.[Type] = 'MANUAL_AUTOMATIC',
					ER.[Qualification] * (
					CASE WHEN (
						CASE FP2.[Penalizes]
							WHEN 'INT' THEN ER.[IdInteraction] 
							WHEN 'GRP' THEN ER.[IdGroup] 
							WHEN 'SGR' THEN ER.[IdSubGroup] 
						END = FP2.[PenalizedOn]
						AND FP2.[Penalized] = 1
					) THEN 0 ELSE 1 END),
					0) 
				)																				'PENALIZED_AUTOMATIC_SCORE',
				SUM(IIF(HA.[Type] = 'MANUAL',
					ER.[Qualification] * (
					CASE WHEN (
						CASE FP2.[Penalizes]
							WHEN 'INT' THEN ER.[IdInteraction] 
							WHEN 'GRP' THEN ER.[IdGroup] 
							WHEN 'SGR' THEN ER.[IdSubGroup] 
						END = FP2.[PenalizedOn]
						AND FP2.[Penalized] = 1
					) THEN 0 ELSE 1 END),
					0) 
				)																				'PENALIZED_MANUAL_SCORE'
			FROM EvaluationResult ER (NOLOCK) 
			LEFT JOIN (
				-- HACEMOS UN CRUCE CON LA TABLA VARIABLE Y TOMAMOS SOLO UNA DE LAS PENALIZACIONES POR INTERACCION, EMPEZANDO 
				--  POR LA MAS PRIORITARIA (FP.[RN])
				SELECT DISTINCT FP.[Instance],
								FP.[IdEvaluationPlan], 
								FP.[IdInteraction], 
								FP.[Penalized],
								FP.[Penalizes], 
								FP.[PenalizedOn]
					FROM CTEFP FP (NOLOCK)
					WHERE FP.[Penalizes] <> 'NO'
						AND FP.[RN] = 1
			) FP2
				ON FP2.[Instance] = ER.[Instance]
					AND ER.[IdEvaluationPlan] = FP2.[IdEvaluationPlan]
					AND ER.[IdInteraction] = FP2.[IdInteraction]
					/*
					AND CASE FP2.[Penalizes]
							WHEN 'INT' THEN ER.[IdInteraction] 
							WHEN 'GRP' THEN ER.[IdGroup] 
							WHEN 'SGR' THEN ER.[IdSubGroup] 
						END = FP2.[PenalizedOn]
					AND FP2.[Penalized] = 1
					*/
			INNER JOIN dbo.[HistoricAbility] HA (NOLOCK)
				ON HA.[VCC] = ER.[Instance]
					AND HA.[EvaluationPlanId] = ER.[IdEvaluationPlan]
					AND HA.[ID] = ER.[IdAbility]
			--WHERE ER.[Instance] = 'multisalud'
			WHERE -- ER.[Instance] = FP2.[Instance] -- ESTA LINEA CAUSA QUE NO SE ACTUALICEN LOS SCORES LAS EVALUACIONES QUE NO PENALIZAN
				-- AND 
				ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM [#AbilityCognitiveTemp])
				--AND ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM DummyEvaluationPlanAbility)
			GROUP BY ER.[Instance],
				ER.[IdEvaluationPlan],
				ER.[IdInteraction],
				ER.[IdAuditor]
	)
	--SELECT * FROM CTEFS

	-- ACTUALIZAMOS LOS REGISTROS DE EVALUACION CON LA NOTA PENALIZADA OBTENIDA EN LOS PASOS ANTERIORES
	UPDATE AEP 
		SET AEP.[Score] = FS.[PENALIZED_SCORE],
			AEP.[AutomaticScore] = FS.[PENALIZED_AUTOMATIC_SCORE],
			AEP.[ManualScore] = FS.[PENALIZED_MANUAL_SCORE],
			AEP.[LastModifiedDate] = GETUTCDATE(),
			AEP.[TimeStamp] = GETUTCDATE()
		FROM AuditorEvaluationPlan AEP (NOLOCK)
		LEFT JOIN CTEFS FS (NOLOCK) 
			ON FS.[Instance] = AEP.[Instance] 
				AND FS.[IdEvaluationPlan] = AEP.[IdEvaluationPlan] 
				AND FS.[IdInteraction] = AEP.[IdInteraction]
				AND FS.[IdAuditor] = AEP.[IdAuditor]
		WHERE FS.[Instance] IS NOT NULL
		
	/*************************************************************************************/
	/*FIN SECCION PARA ACTUALIZAR LA CALIFICACION TOTAL DE LA EVALUACION C/S PENALIZACION*/
	/*************************************************************************************/
     --insert into test(origin,content) values('BulkAbilityCognitive',(select *  from [dbo].[#AbilityCognitiveTemp] FOR JSON AUTO))
	DROP TABLE [dbo].[#AbilityCognitiveTemp];
	
	SET NOCOUNT OFF
END
GO
PRINT N'Actualizando Procedimiento [dbo].[BulkEvaluationPlanQuery]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkEvaluationPlanQuery]';


GO
PRINT N'Actualizando Procedimiento [dbo].[CleanFailedBatchData]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[CleanFailedBatchData]';


GO
PRINT N'Actualizando Procedimiento [dbo].[CleanFailedEvaluationPlanData]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[CleanFailedEvaluationPlanData]';


GO
PRINT N'Actualizando Procedimiento [dbo].[DeleteAuditorEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteAuditorEvaluationPlan]';


GO
PRINT N'Actualizando Procedimiento [dbo].[DeleteAuditorEvaluationPlanByInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteAuditorEvaluationPlanByInteraction]';


GO
PRINT N'Actualizando Procedimiento [dbo].[DeleteEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEvaluationPlan]';


GO
PRINT N'Actualizando Procedimiento [dbo].[DeleteEvaluationPlanInteractionByTypeAndId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEvaluationPlanInteractionByTypeAndId]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetAgentsFromHistoricEvaluationPlans]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAgentsFromHistoricEvaluationPlans]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetAuditorEvaluationPlanEvaluation]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAuditorEvaluationPlanEvaluation]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetAuditorsEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAuditorsEvaluationPlan]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetAuditorsFromEvaluationPlans]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAuditorsFromEvaluationPlans]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetCampaignFulfillment]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetCampaignFulfillment]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetEfectivityPlans]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEfectivityPlans]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetEvaluationFormatsFromHistoricEvaluationPlans]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationFormatsFromHistoricEvaluationPlans]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetEvaluationPlans]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlans]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetEvaluationResultsFromAuditorEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationResultsFromAuditorEvaluationPlan]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetEvaluationReviewCommitments]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationReviewCommitments]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetEvaluationsOfInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationsOfInteraction]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetInteractionsByType]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsByType]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetInteractionsEvaluationPlanWithoutFilters]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsEvaluationPlanWithoutFilters]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetInteractionTypes]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionTypes]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetTeamPerformanceFromEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetTeamPerformanceFromEvaluationPlan]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetTopAgents]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetTopAgents]';


GO
PRINT N'Actualizando Procedimiento [dbo].[RestoreEvaluationResultDraftBackup]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[RestoreEvaluationResultDraftBackup]';


GO
PRINT N'Actualizando Procedimiento [dbo].[SaveAuditorEvPlanResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveAuditorEvPlanResult]';


GO
PRINT N'Actualizando Procedimiento [dbo].[SaveEvaluationFormat]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveEvaluationFormat]';


GO
PRINT N'Actualizando Procedimiento [dbo].[SaveEvaluationPlanCompleted]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveEvaluationPlanCompleted]';


GO
PRINT N'Actualizando Procedimiento [dbo].[SaveEvaluationStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveEvaluationStatus]';


GO
PRINT N'Actualizando Procedimiento [dbo].[SaveEvaluationTipificationBaseResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveEvaluationTipificationBaseResult]';


GO
PRINT N'Actualizando Procedimiento [dbo].[SaveI6InteractionAsyncInteractionForEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveI6InteractionAsyncInteractionForEvaluationPlan]';


GO
PRINT N'Actualizando Procedimiento [dbo].[SaveI6InteractionSyncInteractionForEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveI6InteractionSyncInteractionForEvaluationPlan]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetAuditorsInteractions]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAuditorsInteractions]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetTeamPerformanceFilters]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetTeamPerformanceFilters]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetEvaluationReview]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationReview]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetFiltersFromEvaluation]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetFiltersFromEvaluation]';


GO
PRINT N'Actualizando Procedimiento [dbo].[BulkTipificationInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkTipificationInteraction]';


GO
PRINT N'Actualizando Procedimiento [dbo].[SaveI6InteractionAsyncInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveI6InteractionAsyncInteraction]';


GO
PRINT N'Actualizando Procedimiento [dbo].[SaveI6InteractionAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveI6InteractionAudio]';


GO
PRINT N'Actualizando Procedimiento [dbo].[BulkEvaluationPlanAbility]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkEvaluationPlanAbility]';


GO
PRINT N'Actualizando Procedimiento [dbo].[BulkProgress]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkProgress]';


GO
PRINT N'Actualización completada.';


GO
